#include "date.h"
#include <time.h>
#include <iostream.h>
date renremdate;

class M00_BUILDING_EXPLODE_NO_DAMAGE_DAK : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	void Destroyed(GameObject *obj);
	float TotalHealth;
	int IntHealth;
};

class M00_Disable_Transition : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Timer_Expired(GameObject *obj,int number);
	float TotalHealth;
	int IntHealth;
	Vector3 HarvyPos;
};

class M00_GrantPowerup_Created : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
	void Timer_Expired(GameObject *obj,int number);
	void Destroyed(GameObject *obj);
	GameObject *BackpackObject;
	Vector3 DeathPlace;
	bool IsKamiKaze;
	bool IsSecondWind;
	bool IsTibSuit;
	bool IsDestroyed;
};

class KAK_Backpack : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	char GunToGive[512];
	int SpawnedByID;
};

class KAK_Backpack_Object : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	GameObject *BackpackScript;
	Vector3 DeathPlace;
};

class M00_CNC_Crate : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
	int RandomIntCrate;
	char CrateMessage[512];
	GameObject *vehBlocker;
};

class KAK_Temp_Crate : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};

class M00_Death_Powerup : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};

class KAK_CTM_Mobius : public ScriptImpClass {
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
};

class KAK_CTM_Mobius_Powerup : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Created(GameObject *obj);
	void Action_Complete(GameObject * obj,int action,ActionCompleteReason reason);
	void Timer_Expired(GameObject *obj, int number);
	bool RepeatAction;
};

class KAK_CTM_PedCrate : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};

class KAK_Revert_Controller : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};