#include "stdafx.h"
#include "scripts.h"
#include "kak.h"
#include "PROFILE.h"
#include <stdio.h>
#include <windows.h>
#include <process.h>
#include <fstream>
#include <iostream.h>
#include <string>
#include <stdlib.h>
#include "ddeml.h"
#include <sys/stat.h>

bool Created_Nod_Veh_Zone = false;
bool Created_GDI_Veh_Zone = false;
bool IsRepeate = false;
bool IsCrateCreated = false;
Vector3 GDI_Veh_Spawn;
Vector3 Nod_Veh_Spawn;
Vector3 GDI_Harv_Spawn;
Vector3 Nod_Harv_Spawn;

int GDIGT1Pool;
int GDIGT2Pool;
int NodTurret1Pool;
int NodTurret2Pool;
int NodTurret1DeadID;
int NodTurret2DeadID;

int BarrContID;

HDDEDATA CALLBACK DdeCallback(
    UINT uType,
    UINT uFmt,
    HCONV hconv,
    HSZ hsz1,
    HSZ hsz2,
    HDDEDATA hdata,
    DWORD dwData1,
    DWORD dwData2)
{
    return 0;
}

void DDEPoke(DWORD idInst, HCONV hConv, char* szData)
{
    HSZ hszItem = DdeCreateStringHandle(idInst, "command", 0);
	DdeClientTransaction((LPBYTE)szData, (DWORD)(lstrlen(szData)+1),
                          hConv, hszItem, CF_TEXT,
                          XTYP_POKE, 3000, NULL);
    DdeFreeStringHandle(idInst, hszItem);
}

int SendtoIRC (char* message)
{
	char szApp[20];
    getProfileString("Settings", "DDEName", "null", szApp, 20, "Scripts.ini");
    char szTopic[] = "COMMAND";

    DWORD idInst=0;
    UINT iReturn;
    iReturn = DdeInitialize(&idInst, (PFNCALLBACK)DdeCallback, 
                            APPCLASS_STANDARD | APPCMD_CLIENTONLY, 0 );
    if (iReturn!=DMLERR_NO_ERROR)
    {
        return 1;
    }

    HSZ hszApp, hszTopic;
    HCONV hConv;
    hszApp = DdeCreateStringHandle(idInst, szApp, 0);
    hszTopic = DdeCreateStringHandle(idInst, szTopic, 0);
    hConv = DdeConnect(idInst, hszApp, hszTopic, NULL);
    DdeFreeStringHandle(idInst, hszApp);
    DdeFreeStringHandle(idInst, hszTopic);
    if (hConv == NULL)
    {
        DdeUninitialize(idInst);
        return 2;
    }

    DDEPoke(idInst, hConv, message);
    DdeDisconnect(hConv);
    DdeUninitialize(idInst);

    return 0;
}

void Throw_Player (int ObjectID, float Max_Height, float Speed, float Stop_Loop) {
	Vector3 PositionBuf;
	float Curr_Height, Move_Height, Temp_Height;
	Temp_Height = Max_Height;
	while (Curr_Height < Max_Height) {
		Move_Height = Temp_Height / Speed;
		if (Move_Height < Stop_Loop) Move_Height = 1;
		Curr_Height += Move_Height;
		Temp_Height -= Move_Height;
		if (Curr_Height > Max_Height) Curr_Height = Max_Height;
		
		PositionBuf.Z += Move_Height;
		Commands->Set_Position(Commands->Find_Object(ObjectID),PositionBuf);
	}
	Commands->Apply_Damage(Commands->Find_Object(ObjectID),20,"Earth",false);
}

int Get_Character_Price (const char* Preset) {
	int Price = 0;

	if (strstr(Preset,"CnC_GDI_Engineer_0")) Price = 0;
	else if (strstr(Preset,"CnC_GDI_Engineer_2SF")) Price = 350;
	else if (strstr(Preset,"CnC_GDI_Grenadier_0")) Price = 0;
	else if (strstr(Preset,"CnC_GDI_Grenadier_2SF")) Price = 450;
	else if (strstr(Preset,"CnC_Ignatio_Mobius")) Price = 1000;
	else if (strstr(Preset,"CnC_GDI_MiniGunner_0")) Price = 0;
	else if (strstr(Preset,"CnC_GDI_MiniGunner_1Off")) Price = 175;
	else if (strstr(Preset,"CnC_GDI_MiniGunner_2SF")) Price = 500;
	else if (strstr(Preset,"CnC_GDI_MiniGunner_3Boss")) Price = 1000;
	else if (strstr(Preset,"CnC_GDI_RocketSoldier_0")) Price = 0;
	else if (strstr(Preset,"CnC_GDI_RocketSoldier_1Off")) Price = 225;
	else if (strstr(Preset,"CnC_GDI_RocketSoldier_2SF")) Price = 400;
	else if (strstr(Preset,"CnC_Sydney_PowerSuit")) Price = 1000;
	else if (strstr(Preset,"CnC_Sydney")) Price = 150;
	else if (strstr(Preset,"CnC_Nod_Engineer_0")) Price = 0;
	else if (strstr(Preset,"CnC_Nod_FlameThrower_0")) Price = 0;
	else if (strstr(Preset,"Cnc_Nod_FlameThrower_1Off")) Price = 150;
	else if (strstr(Preset,"Cnc_Nod_FlameThrower_2SF")) Price = 400;
	else if (strstr(Preset,"Cnc_Nod_FlameThrower_3Boss")) Price = 1000;
	else if (strstr(Preset,"Cnc_Nod_Minigunner_0")) Price = 0;
	else if (strstr(Preset,"Cnc_Nod_Minigunner_1Off")) Price = 175;
	else if (strstr(Preset,"Cnc_Nod_Minigunner_2SF")) Price = 500;
	else if (strstr(Preset,"Cnc_Nod_Minigunner_3Boss")) Price = 1000;
	else if (strstr(Preset,"Cnc_Nod_RocketSoldier_0")) Price = 0;
	else if (strstr(Preset,"Cnc_Nod_RocketSoldier_1Off")) Price = 225;
	else if (strstr(Preset,"Cnc_Nod_RocketSoldier_2SF")) Price = 450;
	else if (strstr(Preset,"Cnc_Nod_RocketSoldier_3Boss")) Price = 1000;
	else if (strstr(Preset,"Cnc_Nod_Technician_0")) Price = 350;

	return Price;
}

void Build_Tib_Field(float X1, float X2, float Y1, float Y2, Vector3 TreePos) {
	for (int i = 0; i < 10; i++) {
		Vector3 CrystalLoc;
		CrystalLoc.X = Commands->Get_Random(X1,X2);
		CrystalLoc.Y = Commands->Get_Random(Y1,Y2);
		CrystalLoc.Z = 0.0f;
		Commands->Create_Object("dsp_Tiberium_Grande",CrystalLoc);
	}
	Commands->Create_Object("dsp_TibTree2",TreePos);
}

/* ************************************************************************************************************* */

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Destroyed(GameObject *obj) {
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) 
		rename("Data\\bjects.ddb","Data\\objects.ddb");
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Timer_Expired(GameObject *obj, int number) {
	if (number == 5) {
		//printf("Inside timer..\n");
		//Commands->Apply_Damage(obj,-500,"Repair",false);
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Created(GameObject *obj) {
	TotalHealth = Commands->Get_Health(obj);
	IntHealth = (int)TotalHealth;
	char Health[256];
	sprintf(Health,"/bhealth %s %d None %d",Commands->Get_Preset_Name(obj),IntHealth,(int)Commands->Get_Max_Health(obj));
	SendtoIRC(Health);

	/*totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
	sprintf(buildingID,"%d",Commands->Get_ID(obj));
	sprintf(buildingPosX,"%f",Commands->Get_Position(obj).X);
	sprintf(buildingPosY,"%f",Commands->Get_Position(obj).Y);
	sprintf(buildingPosZ,"%f",Commands->Get_Position(obj).Z);
	sprintf(totalbuildings_string,"%d",totalbuildings);
	sprintf(newtotalbuildings_string,"%d",(totalbuildings + 1));

	writeProfileString("Buildings","TotalAmount",newtotalbuildings_string,"IDNum.dat");
	writeProfileString("Buildings",totalbuildings_string,buildingID,"IDNum.dat");
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Power_Plant")) writeProfileString("Buildings","GDIPP",buildingID,"IDNum.dat");
	else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Power_Plant")) writeProfileString("Buildings","NodPP",buildingID,"IDNum.dat");
	writeProfileString(buildingID,"Name",Commands->Get_Preset_Name(obj),"IDNum.dat");
	writeProfileString(buildingID,"PositionX",buildingPosX,"IDNum.dat");
	writeProfileString(buildingID,"PositionY",buildingPosY,"IDNum.dat");
	writeProfileString(buildingID,"PositionZ",buildingPosZ,"IDNum.dat");*/

	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
		Created_Nod_Veh_Zone = false;
		Created_GDI_Veh_Zone = false;
		IsRepeate = false;
		IsCrateCreated = false;

		rename("Data\\objects.ddb","Data\\bjects.ddb");

		SendtoIRC("/logparse 1 Level loaded OK");
		BarrContID = Commands->Get_ID(obj);

		Vector3 TreePos;
		TreePos.X = -53.329f;
		TreePos.Y = 29.525f;
		TreePos.Z = 2.235f;
		Build_Tib_Field(-57.775f,-20.051f,4.830f,37.947f,TreePos);

		char CurrMap[256], BarrID[50];
		sprintf(BarrID,"%d",Commands->Get_ID(obj));
		getProfileString("Map",BarrID,"Null",CurrMap,256,"gimmeurDATAS.dat");

		GameObject *WeatherController = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
		char ParamsW[10];
		sprintf(ParamsW,"%d",Commands->Get_ID(obj));
		Commands->Attach_Script(WeatherController,"KAK_Random_Weather",ParamsW);

		if (strstr(CurrMap,"C&C_Islands.mix") || strstr(CurrMap,"C&C_Canyon.mix") || strstr(CurrMap,"C&C_Complex.mix") || strstr(CurrMap,"C&C_Volcano.mix") || strstr(CurrMap,"C&C_Walls_Flying.mix") || strstr(CurrMap,"C&C_BunkersTS.mix")) {
			int ToggleBD = getProfileInt(CurrMap,"ToggleBD",1,"gimmeurDATAS.dat");
			if (ToggleBD == 1) {
				Vector3 GDIGT1, GDIGT2, NodTurret1, NodTurret2;
				GameObject *Game_GDIGT1, *Game_GDIGT2, *Game_NodTurret1, *Game_NodTurret2;
				

				GDIGT1.X=(float)getProfileInt(CurrMap,"GDIGT1_X",500,"gimmeurDATAS.dat");
				GDIGT1.Y=(float)getProfileInt(CurrMap,"GDIGT1_Y",500,"gimmeurDATAS.dat");
				GDIGT1.Z=(float)getProfileInt(CurrMap,"GDIGT1_Z",500,"gimmeurDATAS.dat");
				GDIGT2.X=(float)getProfileInt(CurrMap,"GDIGT2_X",500,"gimmeurDATAS.dat");
				GDIGT2.Y=(float)getProfileInt(CurrMap,"GDIGT2_Y",500,"gimmeurDATAS.dat");
				GDIGT2.Z=(float)getProfileInt(CurrMap,"GDIGT2_Z",500,"gimmeurDATAS.dat");

				NodTurret1.X=(float)getProfileInt(CurrMap,"NodTurret1_X",500,"gimmeurDATAS.dat");
				NodTurret1.Y=(float)getProfileInt(CurrMap,"NodTurret1_Y",500,"gimmeurDATAS.dat");
				NodTurret1.Z=(float)getProfileInt(CurrMap,"NodTurret1_Z",500,"gimmeurDATAS.dat");
				NodTurret2.X=(float)getProfileInt(CurrMap,"NodTurret2_X",500,"gimmeurDATAS.dat");
				NodTurret2.Y=(float)getProfileInt(CurrMap,"NodTurret2_Y",500,"gimmeurDATAS.dat");
				NodTurret2.Z=(float)getProfileInt(CurrMap,"NodTurret2_Z",500,"gimmeurDATAS.dat");

				Game_GDIGT1 = Commands->Create_Object("GDI_Guard_Tower",GDIGT1);
				Commands->Set_Player_Type(Game_GDIGT1,1);
				Commands->Attach_Script(Game_GDIGT1,"KAK_Rebuy_BD","1,1");
				Game_GDIGT2 = Commands->Create_Object("GDI_Guard_Tower",GDIGT2);
				Commands->Set_Player_Type(Game_GDIGT2,1);
				Commands->Attach_Script(Game_GDIGT2,"KAK_Rebuy_BD","1,2");
				Commands->Disable_All_Collisions(Game_GDIGT1);
				Commands->Disable_All_Collisions(Game_GDIGT2);

				Game_NodTurret1 = Commands->Create_Object("Nod_Turret_MP_Improved",NodTurret1);
				Commands->Set_Player_Type(Game_NodTurret1,0);
				Commands->Attach_Script(Game_NodTurret1,"KAK_Rebuy_BD","0,1");
				Game_NodTurret2 = Commands->Create_Object("Nod_Turret_MP_Improved",NodTurret2);
				Commands->Set_Player_Type(Game_NodTurret2,0);
				Commands->Attach_Script(Game_NodTurret2,"KAK_Rebuy_BD","0,2");
				Commands->Disable_All_Collisions(Game_NodTurret1);
				Commands->Disable_All_Collisions(Game_NodTurret2);
			}
		}
		else if (strstr(CurrMap,"C&C_City_Flying.mix") || strstr(CurrMap,"C&C_Under.mix") || strstr(CurrMap,"C&C_Hourglass.mix")) {
			Vector3 NodTurret1, NodTurret2;
			GameObject *Game_NodTurret1, *Game_NodTurret2;
			
			NodTurret1.X=(float)getProfileInt(CurrMap,"NodTurret1_X",500,"gimmeurDATAS.dat");
			NodTurret1.Y=(float)getProfileInt(CurrMap,"NodTurret1_Y",500,"gimmeurDATAS.dat");
			NodTurret1.Z=(float)getProfileInt(CurrMap,"NodTurret1_Z",500,"gimmeurDATAS.dat");
			NodTurret2.X=(float)getProfileInt(CurrMap,"NodTurret2_X",500,"gimmeurDATAS.dat");
			NodTurret2.Y=(float)getProfileInt(CurrMap,"NodTurret2_Y",500,"gimmeurDATAS.dat");
			NodTurret2.Z=(float)getProfileInt(CurrMap,"NodTurret2_Z",500,"gimmeurDATAS.dat");

			Game_NodTurret1 = Commands->Create_Object("Nod_Turret_MP_Improved",NodTurret1);
			Commands->Set_Player_Type(Game_NodTurret1,0);
			Commands->Attach_Script(Game_NodTurret1,"KAK_Rebuy_BD","0,1");
			Game_NodTurret2 = Commands->Create_Object("Nod_Turret_MP_Improved",NodTurret2);
			Commands->Set_Player_Type(Game_NodTurret2,0);
			Commands->Attach_Script(Game_NodTurret2,"KAK_Rebuy_BD","0,2");
			Commands->Disable_All_Collisions(Game_NodTurret1);
			Commands->Disable_All_Collisions(Game_NodTurret2);
		}
		else if (strstr(CurrMap,"C&C_Field.mix")) {
			Vector3 NodTurret1, NodTurret2;
			GameObject *Game_NodTurret1, *Game_NodTurret2;
			
			NodTurret1.X=(float)getProfileInt(CurrMap,"NodTurret1_X",500,"gimmeurDATAS.dat");
			NodTurret1.Y=(float)getProfileInt(CurrMap,"NodTurret1_Y",500,"gimmeurDATAS.dat");
			NodTurret1.Z=(float)getProfileInt(CurrMap,"NodTurret1_Z",500,"gimmeurDATAS.dat");
			NodTurret2.X=(float)getProfileInt(CurrMap,"NodTurret2_X",500,"gimmeurDATAS.dat");
			NodTurret2.Y=(float)getProfileInt(CurrMap,"NodTurret2_Y",500,"gimmeurDATAS.dat");
			NodTurret2.Z=(float)getProfileInt(CurrMap,"NodTurret2_Z",500,"gimmeurDATAS.dat");

			Commands->Destroy_Object(Commands->Find_Object(getProfileInt(CurrMap,"BadSpawnID",1500733,"gimmeurDATAS.dat")));

			Game_NodTurret1 = Commands->Create_Object("Nod_Turret_MP_Improved",NodTurret1);
			Commands->Set_Player_Type(Game_NodTurret1,0);
			Commands->Attach_Script(Game_NodTurret1,"KAK_Rebuy_BD","0,1");
			Game_NodTurret2 = Commands->Create_Object("Nod_Turret_MP_Improved",NodTurret2);
			Commands->Set_Player_Type(Game_NodTurret2,0);
			Commands->Attach_Script(Game_NodTurret2,"KAK_Rebuy_BD","0,2");
			Commands->Disable_All_Collisions(Game_NodTurret1);
			Commands->Disable_All_Collisions(Game_NodTurret2);
		}
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Damaged(GameObject *obj, GameObject *damager, float damage)
{
	static bool Sent500 = true;
	TotalHealth -= damage;
	if ((int)TotalHealth <= (IntHealth - 10)) {
		Sent500 = false;
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
	else if ((int)TotalHealth >= (IntHealth + 10)) {
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
	else if ((int)TotalHealth == 500 && Sent500 == false) {
		Sent500 = true;
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Killed(GameObject * obj,GameObject * shooter)
{
	char Health[256];
	if (Commands->Get_Player_Type(shooter) == 1)
		sprintf(Health,"/bdead %s %d %d %dGDI",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Max_Health(obj),(int)Commands->Get_Points(shooter));
	else if (Commands->Get_Player_Type(shooter) == 2)
		sprintf(Health,"/bdead %s %d %d %dNod",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Max_Health(obj),(int)Commands->Get_Points(shooter));
	else
		sprintf(Health,"/bdead %s %d %d",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Max_Health(obj));

	SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
	SendtoIRC(Health);

	/*char numbertolook[100];
	char IDtolook[100];
	char WhatIDIs[100];
	totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
	for (int i = 0; i < totalbuildings; i++) {
		sprintf(numbertolook,"%d",i);
		sprintf(IDtolook,"%d",Commands->Get_ID(obj));
		getProfileString("Buildings",numbertolook,"null",WhatIDIs,100,"IDNum.dat");
		if (strstr(WhatIDIs,IDtolook)) writeProfileString("Buildings",numbertolook,"dead","IDNum.dat");
	}
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Power_Plant"))
		writeProfileString("Buildings","GDIPP","dead","IDNum.dat");
	else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Power_Plant"))
		writeProfileString("Buildings","NodPP","dead","IDNum.dat");*/

	Commands->Start_Timer(obj,this,5,5);
}

/* ************************************************************************************************************* */

void KAK_Rebuy_BD::Killed(GameObject *obj, GameObject *shooter) {
	char CurrMap[256];
	Vector3 DeathCrateLocation;
	GameObject *deathcrate;
	getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");

	if (Get_Int_Parameter("PlayerType") == 1) {
		if (Get_Int_Parameter("BDNum") == 1) {
			DeathCrateLocation.X=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_X",0,"gimmeurDATAS.dat");
			DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_Y",0,"gimmeurDATAS.dat");
			DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_Z",0,"gimmeurDATAS.dat");
			deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
			Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","1,GDIGT1");
		}
		else if (Get_Int_Parameter("BDNum") == 2) {
			DeathCrateLocation.X=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_X",0,"gimmeurDATAS.dat");
			DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_Y",0,"gimmeurDATAS.dat");
			DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_Z",0,"gimmeurDATAS.dat");
			deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
			Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","1,GDIGT2");
		}
	}
	else if (Get_Int_Parameter("PlayerType") == 0) {
		if (Get_Int_Parameter("BDNum") == 1) {
			DeathCrateLocation.X=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_X",0,"gimmeurDATAS.dat");
			DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_Y",0,"gimmeurDATAS.dat");
			DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_Z",0,"gimmeurDATAS.dat");
			deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
			GameObject *deadturret = Commands->Create_Object("Nod_Turret_Destroyed",Commands->Get_Position(obj));
			Commands->Disable_All_Collisions(deadturret);
			NodTurret1DeadID = Commands->Get_ID(deadturret);
			Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","0,NodTurret1");
		}
		else if (Get_Int_Parameter("BDNum") == 2) {
			DeathCrateLocation.X=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_X",0,"gimmeurDATAS.dat");
			DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_Y",0,"gimmeurDATAS.dat");
			DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_Z",0,"gimmeurDATAS.dat");
			deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
			GameObject *deadturret = Commands->Create_Object("Nod_Turret_Destroyed",Commands->Get_Position(obj));
			Commands->Disable_All_Collisions(deadturret);
			NodTurret2DeadID = Commands->Get_ID(deadturret);
			Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","0,NodTurret2");
		}
	}
}

void KAK_Rebuy_Box::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	int PlayerCreds = Commands->Get_Money(sender);

	if (message == 121646156) {
		if (param == 1) {
			Commands->Start_Timer(obj,this,2,1);
		}
		else if (param == 2) {
			Commands->Start_Timer(obj,this,2,2);
		}
		else if (param == 3) {
			Commands->Start_Timer(obj,this,2,3);
		}
		else if (param == 4) {
			Commands->Start_Timer(obj,this,2,4);
		}
	}
	else if (message == 1000000025) {
		if (Commands->Get_Player_Type(sender) == Get_Int_Parameter("PlayerType")) {
			if (PlayerCreds > 0) {
				if (strstr(Get_Parameter("BDName"),"GDIGT1")) {
					if (PlayerCreds < 100) {
						GDIGT1Pool += PlayerCreds;
						Commands->Give_Money(sender,(PlayerCreds * -1),false);
					}
					else {
						if ((GDIGT1Pool + 100) > 2000) {
							int moneytotake = (100 - ((GDIGT1Pool + 100) - 2000));
							GDIGT1Pool += moneytotake;
							Commands->Give_Money(sender,(moneytotake * -1),false);
						}
						else {
							GDIGT1Pool += 100;
							Commands->Give_Money(sender,-100,false);
						}
					}

					char MessagetoIRC[512];
					sprintf(MessagetoIRC,"/poolinfo GDIGT1 %d",GDIGT1Pool);
					SendtoIRC(MessagetoIRC);

					char CurrMap[256];
					getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");
					if (GDIGT1Pool >= 2000) {
						GDIGT1Pool = 0;
						Vector3 NewGDIGT1;
						NewGDIGT1.X = (float)getProfileInt(CurrMap,"GDIGT1_X",0,"gimmeurDATAS.dat");
						NewGDIGT1.Y = (float)getProfileInt(CurrMap,"GDIGT1_Y",0,"gimmeurDATAS.dat");
						NewGDIGT1.Z = (float)getProfileInt(CurrMap,"GDIGT1_Z",0,"gimmeurDATAS.dat");
						GameObject *Game_GDIGT1 = Commands->Create_Object("GDI_Guard_Tower",NewGDIGT1);
						Commands->Disable_All_Collisions(Game_GDIGT1);
						Commands->Set_Player_Type(Game_GDIGT1,1);
						Commands->Attach_Script(Game_GDIGT1,"KAK_Rebuy_BD","1,1");
						sprintf(MessagetoIRC,"/poolinfo GDIGT1 bought");
						SendtoIRC(MessagetoIRC);
					}
					else {
						GameObject *tempCrate = Commands->Create_Object("Invisible_Object",Commands->Get_Position(sender));
						Commands->Attach_Script(tempCrate,"KAK_Rebuy_Box","2,0");
						Commands->Send_Custom_Event(obj,tempCrate,121646156,1,0);
					}
				}
				else if (strstr(Get_Parameter("BDName"),"GDIGT2")) {
					if (PlayerCreds < 100) {
						GDIGT2Pool += PlayerCreds;
						Commands->Give_Money(sender,(PlayerCreds * -1),false);
					}
					else {
						if ((GDIGT2Pool + 100) > 2000) {
							int moneytotake = (100 - ((GDIGT2Pool + 100) - 2000));
							GDIGT2Pool += moneytotake;
							Commands->Give_Money(sender,(moneytotake * -1),false);
						}
						else {
							GDIGT2Pool += 100;
							Commands->Give_Money(sender,-100,false);
						}
					}

					char MessagetoIRC[512];
					sprintf(MessagetoIRC,"/poolinfo GDIGT2 %d",GDIGT2Pool);
					SendtoIRC(MessagetoIRC);

					char CurrMap[256];
					getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");
					if (GDIGT2Pool >= 2000) {
						GDIGT2Pool = 0;
						Vector3 NewGDIGT2;
						NewGDIGT2.X = (float)getProfileInt(CurrMap,"GDIGT2_X",0,"gimmeurDATAS.dat");
						NewGDIGT2.Y = (float)getProfileInt(CurrMap,"GDIGT2_Y",0,"gimmeurDATAS.dat");
						NewGDIGT2.Z = (float)getProfileInt(CurrMap,"GDIGT2_Z",0,"gimmeurDATAS.dat");
						GameObject *Game_GDIGT2 = Commands->Create_Object("GDI_Guard_Tower",NewGDIGT2);
						Commands->Disable_All_Collisions(Game_GDIGT2);
						Commands->Set_Player_Type(Game_GDIGT2,1);
						Commands->Attach_Script(Game_GDIGT2,"KAK_Rebuy_BD","1,2");
						sprintf(MessagetoIRC,"/poolinfo GDIGT2 bought");
						SendtoIRC(MessagetoIRC);
					}
					else {
						GameObject *tempCrate = Commands->Create_Object("Invisible_Object",Commands->Get_Position(sender));
						Commands->Attach_Script(tempCrate,"KAK_Rebuy_Box","2,0");
						Commands->Send_Custom_Event(obj,tempCrate,121646156,2,0);
					}
				}
				else if (strstr(Get_Parameter("BDName"),"NodTurret1")) {
					if (PlayerCreds < 100) {
						NodTurret1Pool += PlayerCreds;
						Commands->Give_Money(sender,(PlayerCreds * -1),false);
					}
					else {
						if ((NodTurret1Pool + 100) > 2000) {
							int moneytotake = (100 - ((NodTurret1Pool + 100) - 2000));
							NodTurret1Pool += moneytotake;
							Commands->Give_Money(sender,(moneytotake * -1),false);
						}
						else {
							NodTurret1Pool += 100;
							Commands->Give_Money(sender,-100,false);
						}
					}

					char MessagetoIRC[512];
					sprintf(MessagetoIRC,"/poolinfo NodTurret1 %d",NodTurret1Pool);
					SendtoIRC(MessagetoIRC);

					char CurrMap[256];
					getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");
					if (NodTurret1Pool >= 2000) {
						NodTurret1Pool = 0;
						Vector3 NewNodTurret1;
						NewNodTurret1.X = (float)getProfileInt(CurrMap,"NodTurret1_X",0,"gimmeurDATAS.dat");
						NewNodTurret1.Y = (float)getProfileInt(CurrMap,"NodTurret1_Y",0,"gimmeurDATAS.dat");
						NewNodTurret1.Z = (float)getProfileInt(CurrMap,"NodTurret1_Z",0,"gimmeurDATAS.dat");
						GameObject *deadturret = Commands->Find_Object(NodTurret1DeadID);
						Commands->Disable_All_Collisions(deadturret);
						Commands->Destroy_Object(deadturret);
						GameObject *Game_NodTurret1 = Commands->Create_Object("Nod_Turret_MP_Improved",NewNodTurret1);
						Commands->Disable_All_Collisions(Game_NodTurret1);
						Commands->Set_Player_Type(Game_NodTurret1,0);
						Commands->Attach_Script(Game_NodTurret1,"KAK_Rebuy_BD","0,1");
						sprintf(MessagetoIRC,"/poolinfo NodTurret1 bought");
						SendtoIRC(MessagetoIRC);
					}
					else {
						GameObject *tempCrate = Commands->Create_Object("Invisible_Object",Commands->Get_Position(sender));
						Commands->Attach_Script(tempCrate,"KAK_Rebuy_Box","2,0");
						Commands->Send_Custom_Event(obj,tempCrate,121646156,3,0);
					}
				}
				else if (strstr(Get_Parameter("BDName"),"NodTurret2")) {
					if (PlayerCreds < 100) {
						NodTurret2Pool += PlayerCreds;
						Commands->Give_Money(sender,(PlayerCreds * -1),false);
					}
					else {
						if ((NodTurret2Pool + 100) > 2000) {
							int moneytotake = (100 - ((NodTurret2Pool + 100) - 2000));
							NodTurret2Pool += moneytotake;
							Commands->Give_Money(sender,(moneytotake * -1),false);
						}
						else {
							NodTurret2Pool += 100;
							Commands->Give_Money(sender,-100,false);
						}
					}

					char MessagetoIRC[512];
					sprintf(MessagetoIRC,"/poolinfo NodTurret2 %d",NodTurret2Pool);
					SendtoIRC(MessagetoIRC);

					char CurrMap[256];
					getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");
					if (NodTurret2Pool >= 2000) {
						NodTurret2Pool = 0;
						Vector3 NewNodTurret2;
						NewNodTurret2.X = (float)getProfileInt(CurrMap,"NodTurret2_X",0,"gimmeurDATAS.dat");
						NewNodTurret2.Y = (float)getProfileInt(CurrMap,"NodTurret2_Y",0,"gimmeurDATAS.dat");
						NewNodTurret2.Z = (float)getProfileInt(CurrMap,"NodTurret2_Z",0,"gimmeurDATAS.dat");
						GameObject *deadturret = Commands->Find_Object(NodTurret2DeadID);
						Commands->Destroy_Object(deadturret);
						Commands->Disable_All_Collisions(deadturret);
						GameObject *Game_NodTurret2 = Commands->Create_Object("Nod_Turret_MP_Improved",NewNodTurret2);
						Commands->Disable_All_Collisions(Game_NodTurret2);
						Commands->Set_Player_Type(Game_NodTurret2,0);
						Commands->Attach_Script(Game_NodTurret2,"KAK_Rebuy_BD","0,2");
						sprintf(MessagetoIRC,"/poolinfo NodTurret2 bought");
						SendtoIRC(MessagetoIRC);
					}
					else {
						GameObject *tempCrate = Commands->Create_Object("Invisible_Object",Commands->Get_Position(sender));
						Commands->Attach_Script(tempCrate,"KAK_Rebuy_Box","2,0");
						Commands->Send_Custom_Event(obj,tempCrate,121646156,4,0);
					}
				}
			}
		}
		else {
			char CurrMap[256];
			getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");

			if (strstr(Get_Parameter("BDName"),"GDIGT1")) {
				Vector3 DeathCrateLocation;
				DeathCrateLocation.X=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_X",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_Y",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_Z",0,"gimmeurDATAS.dat");
				GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
				Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","1,GDIGT1");
			}
			else if (strstr(Get_Parameter("BDName"),"GDIGT2")) {
				Vector3 DeathCrateLocation;
				DeathCrateLocation.X=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_X",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_Y",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_Z",0,"gimmeurDATAS.dat");
				GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
				Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","1,GDIGT2");
			}
			else if (strstr(Get_Parameter("BDName"),"NodTurret1")) {
				Vector3 DeathCrateLocation;
				DeathCrateLocation.X=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_X",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_Y",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_Z",0,"gimmeurDATAS.dat");
				GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
				Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","0,NodTurret1");
			}
			else if (strstr(Get_Parameter("BDName"),"NodTurret2")) {
				Vector3 DeathCrateLocation;
				DeathCrateLocation.X=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_X",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_Y",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_Z",0,"gimmeurDATAS.dat");
				GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
				Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","0,NodTurret2");
			}
		}
	}
}

void KAK_Rebuy_Box::Timer_Expired(GameObject *obj, int number) {
	char CurrMap[256];
	getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");

	if (number == 1) {
		Vector3 DeathCrateLocation;
		DeathCrateLocation.X=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_X",0,"gimmeurDATAS.dat");
		DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_Y",0,"gimmeurDATAS.dat");
		DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"GDIGT1Rebuy_Z",0,"gimmeurDATAS.dat");
		GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
		Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","1,GDIGT1");
	}
	else if (number == 2) {
		Vector3 DeathCrateLocation;
		DeathCrateLocation.X=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_X",0,"gimmeurDATAS.dat");
		DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_Y",0,"gimmeurDATAS.dat");
		DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"GDIGT2Rebuy_Z",0,"gimmeurDATAS.dat");
		GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
		Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","1,GDIGT2");
	}
	else if (number == 3) {
		Vector3 DeathCrateLocation;
		DeathCrateLocation.X=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_X",0,"gimmeurDATAS.dat");
		DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_Y",0,"gimmeurDATAS.dat");
		DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"NodTurret1Rebuy_Z",0,"gimmeurDATAS.dat");
		GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
		Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","0,NodTurret1");
	}
	else if (number == 4) {
		Vector3 DeathCrateLocation;
		DeathCrateLocation.X=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_X",0,"gimmeurDATAS.dat");
		DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_Y",0,"gimmeurDATAS.dat");
		DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"NodTurret2Rebuy_Z",0,"gimmeurDATAS.dat");
		GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
		Commands->Attach_Script(deathcrate,"KAK_Rebuy_Box","0,NodTurret2");
	}

	Commands->Destroy_Object(obj);
}

/* ************************************************************************************************************* */

void M00_Disable_Transition::Created(GameObject *obj) {
	TotalHealth = Commands->Get_Health(obj);
	IntHealth = (int)TotalHealth;
	char Health[256];
	sprintf(Health,"/bhealth %s %d None %d",Commands->Get_Preset_Name(obj),IntHealth,(int)Commands->Get_Max_Health(obj));
	SendtoIRC(Health);

	if (strstr(Commands->Get_Preset_Name(obj),"Nod_Turret_MP") || strstr(Commands->Get_Preset_Name(obj),"Nod_Turret_MP_Super")) {
		if (!strstr(Commands->Get_Preset_Name(obj),"_Improved")) {
			char CurrMap[256];
			getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");
			if (strstr(CurrMap,"C&C_Islands.mix") || strstr(CurrMap,"C&C_Canyon.mix") || strstr(CurrMap,"C&C_Complex.mix") || strstr(CurrMap,"C&C_Volcano.mix") || strstr(CurrMap,"C&C_Walls_Flying.mix") || strstr(CurrMap,"C&C_City_Flying.mix") || strstr(CurrMap,"C&C_Under.mix") || strstr(CurrMap,"C&C_Hourglass.mix") || strstr(CurrMap,"C&C_Field.mix") || strstr(CurrMap,"C&C_BunkersTS.mix")) {
				Commands->Destroy_Object(obj);	
			}
			else {
				Commands->Destroy_Object(obj);
				GameObject *TurretBlah = Commands->Create_Object("Nod_Turret_MP_Improved",Commands->Get_Position(obj));
				Commands->Disable_All_Collisions(TurretBlah);
			}
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"_Improved")) {
			Commands->Attach_Script(obj,"M00_Vehicle_Regen_DAK","");
			/*totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
			sprintf(buildingID,"%d",Commands->Get_ID(obj));
			sprintf(buildingPosX,"%f",Commands->Get_Position(obj).X);
			sprintf(buildingPosY,"%f",Commands->Get_Position(obj).Y);
			sprintf(buildingPosZ,"%f",Commands->Get_Position(obj).Z);
			sprintf(totalbuildings_string,"%d",totalbuildings);
			sprintf(newtotalbuildings_string,"%d",(totalbuildings + 1));

			writeProfileString("Buildings","TotalAmount",newtotalbuildings_string,"IDNum.dat");
			writeProfileString("Buildings",totalbuildings_string,buildingID,"IDNum.dat");
			if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Power_Plant")) writeProfileString("Buildings","GDIPP",buildingID,"IDNum.dat");
			else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Power_Plant")) writeProfileString("Buildings","NodPP",buildingID,"IDNum.dat");
			writeProfileString(buildingID,"Name",Commands->Get_Preset_Name(obj),"IDNum.dat");
			writeProfileString(buildingID,"PositionX",buildingPosX,"IDNum.dat");
			writeProfileString(buildingID,"PositionY",buildingPosY,"IDNum.dat");
			writeProfileString(buildingID,"PositionZ",buildingPosZ,"IDNum.dat");*/
		}
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"GDI_Guard_Tower")) {
		char CurrMap[256], BarrID[50];
		sprintf(BarrID,"%d",BarrContID);
		getProfileString("Map",BarrID,"Null",CurrMap,256,"gimmeurDATAS.dat");

		if (strstr(CurrMap,"C&C_BunkersTS.mix")) {
			Commands->Destroy_Object(Commands->Find_Object(100001));
			Commands->Destroy_Object(Commands->Find_Object(100314));
		}
		Commands->Attach_Script(obj,"M00_Vehicle_Regen_DAK","");
		/*totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
		sprintf(buildingID,"%d",Commands->Get_ID(obj));
		sprintf(buildingPosX,"%f",Commands->Get_Position(obj).X);
		sprintf(buildingPosY,"%f",Commands->Get_Position(obj).Y);
		sprintf(buildingPosZ,"%f",Commands->Get_Position(obj).Z);
		sprintf(totalbuildings_string,"%d",totalbuildings);
		sprintf(newtotalbuildings_string,"%d",(totalbuildings + 1));

		writeProfileString("Buildings","TotalAmount",newtotalbuildings_string,"IDNum.dat");
		writeProfileString("Buildings",totalbuildings_string,buildingID,"IDNum.dat");
		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Power_Plant")) writeProfileString("Buildings","GDIPP",buildingID,"IDNum.dat");
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Power_Plant")) writeProfileString("Buildings","NodPP",buildingID,"IDNum.dat");
		writeProfileString(buildingID,"Name",Commands->Get_Preset_Name(obj),"IDNum.dat");
		writeProfileString(buildingID,"PositionX",buildingPosX,"IDNum.dat");
		writeProfileString(buildingID,"PositionY",buildingPosY,"IDNum.dat");
		writeProfileString(buildingID,"PositionZ",buildingPosZ,"IDNum.dat");*/
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) {
		if (Created_Nod_Veh_Zone == false) {
			Created_Nod_Veh_Zone = true;
			Nod_Veh_Spawn.X = 0;
			Nod_Veh_Spawn.Y = 0;
			Nod_Veh_Spawn.Z = 0;
			HarvyPos.X = 0;
			HarvyPos.Y = 0;
			HarvyPos.Z = 0;
			Commands->Start_Timer(obj,this,10,1);
		}
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester")) {
		if (Created_GDI_Veh_Zone == false) {
			Created_GDI_Veh_Zone = true;
			GDI_Veh_Spawn.X = 0;
			GDI_Veh_Spawn.Y = 0;
			GDI_Veh_Spawn.Z = 0;
			HarvyPos.X = 0;
			HarvyPos.Y = 0;
			HarvyPos.Z = 0;
			Commands->Start_Timer(obj,this,4,0);
		}
	}
}

void M00_Disable_Transition::Timer_Expired(GameObject *obj,int number) {
	HarvyPos = Commands->Get_Position(obj);
	if (number == 0) {
		GDI_Veh_Spawn = HarvyPos;
		GDI_Veh_Spawn.Z += 3.0f;
		GDI_Harv_Spawn = HarvyPos;
	}
	else if (number == 1) {
		Nod_Veh_Spawn = HarvyPos;
		Nod_Veh_Spawn.Z += 3.0f;
		Nod_Harv_Spawn = HarvyPos;
	}
}

void M00_Disable_Transition::Damaged(GameObject *obj, GameObject *damager, float damage) {
	static bool Sent500 = true;
	TotalHealth -= damage;
	if ((int)TotalHealth <= (IntHealth - 10)) {
		Sent500 = false;
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
	else if ((int)TotalHealth >= (IntHealth + 10)) {
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
	else if ((int)TotalHealth == 500 && Sent500 == false) {
		Sent500 = true;
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
}

void M00_Disable_Transition::Killed(GameObject * obj,GameObject * shooter) {
	char Health[256];
	if (Commands->Get_Player_Type(shooter) == 1)
		sprintf(Health,"/bdead %s %d %d %dGDI",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Max_Health(obj),(int)Commands->Get_Points(shooter));
	else if (Commands->Get_Player_Type(shooter) == 2)
		sprintf(Health,"/bdead %s %d %d %dNod",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Max_Health(obj),(int)Commands->Get_Points(shooter));
	else
		sprintf(Health,"/bdead %s %d %d",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Max_Health(obj));

	SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
	SendtoIRC(Health);

	/*if (strstr(Commands->Get_Preset_Name(obj),"Nod_Turret_MP_Improved")) {
		//Commands->Create_Object("Nod_Turret_Destroyed",Commands->Get_Position(obj));
		char numbertolook[100];
		char IDtolook[100];
		char WhatIDIs[100];
		totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
		for (int i = 0; i < totalbuildings; i++) {
			sprintf(numbertolook,"%d",i);
			sprintf(IDtolook,"%d",Commands->Get_ID(obj));
			getProfileString("Buildings",numbertolook,"null",WhatIDIs,100,"IDNum.dat");
			if (strstr(WhatIDIs,IDtolook)) writeProfileString("Buildings",numbertolook,"dead","IDNum.dat");
		}
	}

	else if (strstr(Commands->Get_Preset_Name(obj),"GDI_Guard_Tower")) {
		char numbertolook[100];
		char IDtolook[100];
		char WhatIDIs[100];
		totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
		for (int i = 0; i < totalbuildings; i++) {
			sprintf(numbertolook,"%d",i);
			sprintf(IDtolook,"%d",Commands->Get_ID(obj));
			getProfileString("Buildings",numbertolook,"null",WhatIDIs,100,"IDNum.dat");
			if (strstr(WhatIDIs,IDtolook)) writeProfileString("Buildings",numbertolook,"dead","IDNum.dat");
		}
	}*/
}

/* ************************************************************************************************************* */

void M00_GrantPowerup_Created::Created(GameObject *obj) {
	//Commands->Create_Object_At_Bone(obj,Get_Parameter("WeaponDef"),"muzzle");
	Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),false);
	IsKamiKaze = false;
	IsSecondWind = false;
	IsTibSuit = false;

	if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		char IDFile[50], LastCharacter[100];
		sprintf(IDFile,"PL%d",Commands->Get_ID(obj));
		int TotalWeapons = getProfileInt("Guns","Total",0,IDFile);

		if (TotalWeapons == 0) {
			writeProfileString("Guns","Total","0",IDFile);
		}
		else {
			int TotalWeapons = getProfileInt("Guns","Total",0,IDFile);
			int CurrWeapon = 1;
			while (CurrWeapon <= TotalWeapons) {
				char WeaponToGive[100], WeaponString[25];
				sprintf(WeaponString,"Weapon%d",CurrWeapon);
				getProfileString("Guns",WeaponString,"null",WeaponToGive,100,IDFile);
				Commands->Give_Powerup(obj,WeaponToGive,true);
				CurrWeapon++;
			}
		}

		getProfileString("Info","LastCharacter","",LastCharacter,100,IDFile);
		Commands->Give_Money(obj,Get_Character_Price(Commands->Get_Preset_Name(obj)),false);
		Commands->Give_Money(obj,(Get_Character_Price(LastCharacter) - Get_Character_Price(Commands->Get_Preset_Name(obj))),false);
		writeProfileString("Info","LastCharacter",Commands->Get_Preset_Name(obj),IDFile);
	}
}

void M00_GrantPowerup_Created::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (IsSecondWind == true) {
		if (Commands->Get_Health(obj) <= 25 && Commands->Get_Health(obj) > 0) {
			Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
			Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
			IsSecondWind = false;
		}
	}
	else if (IsTibSuit == true) {
		Commands->Set_Shield_Type(obj,"ShieldChemWarrior");
	}
}

void M00_GrantPowerup_Created::Killed(GameObject *obj, GameObject *shooter) {
	if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		DeathPlace = Commands->Get_Position(obj);

		if (IsKamiKaze == true) {
			for (int i = 0; i < 16; i++) {
				Commands->Create_Explosion("Explosion_Mine_Remote_01",DeathPlace,0);
			}
		}

		BackpackObject = Commands->Create_Object("Invisible_Object",DeathPlace);
		Commands->Attach_Script(BackpackObject,"KAK_Backpack_Object",Commands->Get_Preset_Name(obj));

		/*char Message[256];
		if (Commands->Get_Player_Type(shooter) == 1) {
			if (Commands->Get_Player_Type(obj) == 0)
				sprintf(Message,"/pkill %s %d %dGDI %s %d %dNod",Commands->Get_Preset_Name(shooter),Commands->Get_ID(shooter),(int)Commands->Get_Points(shooter),Commands->Get_Preset_Name(obj),Commands->Get_ID(obj),(int)Commands->Get_Points(obj));
			else if (Commands->Get_Player_Type(obj) == 1)
				sprintf(Message,"/pkill %s %d %dGDI %s %d %dGDI",Commands->Get_Preset_Name(shooter),Commands->Get_ID(shooter),(int)Commands->Get_Points(shooter),Commands->Get_Preset_Name(obj),Commands->Get_ID(obj),(int)Commands->Get_Points(obj));
		}
		else if (Commands->Get_Player_Type(shooter) == 0) {
			if (Commands->Get_Player_Type(obj) == 0)
				sprintf(Message,"/pkill %s %d %dNod %s %d %dNod",Commands->Get_Preset_Name(shooter),Commands->Get_ID(shooter),(int)Commands->Get_Points(shooter),Commands->Get_Preset_Name(obj),Commands->Get_ID(obj),(int)Commands->Get_Points(obj));
			else if (Commands->Get_Player_Type(obj) == 1)
				sprintf(Message,"/pkill %s %d %dNod %s %d %dGDI",Commands->Get_Preset_Name(shooter),Commands->Get_ID(shooter),(int)Commands->Get_Points(shooter),Commands->Get_Preset_Name(obj),Commands->Get_ID(obj),(int)Commands->Get_Points(obj));
		}
		SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
		SendtoIRC(Message);*/
	}
}

void M00_GrantPowerup_Created::Destroyed(GameObject *obj) {
	if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		char IDFile[50];
		sprintf(IDFile,"del PL%d",Commands->Get_ID(obj));
		system(IDFile);
	}
}

void M00_GrantPowerup_Created::Timer_Expired(GameObject *obj, int number) {
	if (number == 0) {
		BackpackObject = Commands->Create_Object("POW_Health_025",DeathPlace);
		Commands->Attach_Script(BackpackObject,"M00_Powerup_Destroy","");
	}
	else if (number == 1) {
		BackpackObject = Commands->Create_Object("POW_Armor_025",DeathPlace);
		Commands->Attach_Script(BackpackObject,"M00_Powerup_Destroy","");
	}
}

void M00_GrantPowerup_Created::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 250000) {
		IsKamiKaze = true;
	}
	else if (message == 260000) {
		IsSecondWind = true;
	}
	else if (message == 270000) {
		IsTibSuit = true;
	}
	else if (message == 28000) {
		IsKamiKaze = false;
		IsSecondWind = false;
		IsTibSuit = false;
	}
}

/* ************************************************************************************************************* */

void KAK_Backpack_Object::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,1);
}

void KAK_Backpack_Object::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		DeathPlace = Commands->Get_Position(obj);

		int RandomNum = Commands->Get_Random_Int(1,4);

		if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player_Nod",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_ChemSprayer_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_0")) {
			BackpackScript = Commands->Create_Object("POW_Flamethrower_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_0")) {
			BackpackScript = Commands->Create_Object("POW_GrenadeLauncher_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserChaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Technician_0")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney_PowerSuit")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_PersonalIonCannon_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_Railgun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_TiberiumAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_TiberiumFlechetteGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Ignatio_Mobius")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_VoltAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("CnC_POW_VoltAutoRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else {
			BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		Commands->Send_Custom_Event(obj,BackpackScript,6000,Commands->Get_ID(obj),0);
	}
}

void KAK_Backpack::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 6000) {
		SpawnedByID = param;
	}
	else if (message == 1000000025) {
		if (SpawnedByID != Commands->Get_ID(sender)) {
			char IDFile[50], Weapons[10], WeaponString[25];
			sprintf(IDFile,"PL%d",Commands->Get_ID(sender));
			int TotalWeapons = getProfileInt("Guns","Total",0,IDFile);
			TotalWeapons++;
			sprintf(Weapons,"%d",TotalWeapons);
			sprintf(WeaponString,"Weapon%d",TotalWeapons);
			writeProfileString("Guns","Total",Weapons,IDFile);
			writeProfileString("Guns",WeaponString,Commands->Get_Preset_Name(obj),IDFile);
		}
	}
}

/* ************************************************************************************************************* */

void M00_CNC_Crate::Created(GameObject *obj) {
	if (IsCrateCreated == false) {
		vehBlocker = Commands->Create_Object("Vehicle_Blocker",Commands->Get_Position(obj));
		IsCrateCreated = true;
	}
}

void M00_CNC_Crate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000025) {
		if (IsRepeate == false) {
			IsRepeate = true;
			Commands->Destroy_Object(vehBlocker);
			IsCrateCreated = false;
			GameObject *tempObj = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
			Commands->Attach_Script(tempObj,"KAK_Temp_Crate","");
			Commands->Send_Custom_Event(sender,tempObj,990000,0,1);
			RandomIntCrate = Commands->Get_Random_Int(1,101);

			// Points and Depoints Crate
			if (RandomIntCrate > 0 && RandomIntCrate <= 14) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Points(sender,500,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Points(sender,250,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Points(sender,125,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 125", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Points(sender,50,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 50", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Points(sender,50,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 50", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Points(sender,-500,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Points(sender,-250,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Points(sender,-125,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 125", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Points(sender,-50,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 50", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Points(sender,-50,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 50", Commands->Get_Player_Type(sender));
					}
				}
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

		
			//Money and Demoney Crate
			else if (RandomIntCrate > 14 && RandomIntCrate <= 28) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Money(sender,1000,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 1000", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Money(sender,500,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Money(sender,250,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Money(sender,100,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Money(sender,100,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 100", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Money(sender,-1000,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 1000", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Money(sender,-500,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Money(sender,-250,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Money(sender,-100,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Money(sender,-100,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					if (Commands->Get_Money(sender) < 0) Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
				}
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Random Weapon Crate
			else if (RandomIntCrate > 28 && RandomIntCrate <= 43) {
				int RandomWeapNum = Commands->Get_Random_Int(1,201);
				if (RandomWeapNum > 0 && RandomWeapNum <= 20) {
					Commands->Give_Powerup(sender,"POW_AutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d AutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 20 && RandomWeapNum <= 40) {
					Commands->Give_Powerup(sender,"POW_Shotgun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Shotgun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 40 && RandomWeapNum <= 60) {
					Commands->Give_Powerup(sender,"POW_Flamethrower_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Flamethrower", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 60 && RandomWeapNum <= 80) {
					Commands->Give_Powerup(sender,"POW_GrenadeLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d GrenadeLauncher", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 80 && RandomWeapNum <= 100) {
					Commands->Give_Powerup(sender,"POW_RepairGun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RepairGunWeak", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 100 && RandomWeapNum <= 120) {
					Commands->Give_Powerup(sender,"CnC_POW_MineRemote_02",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RemoteMine2", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 120 && RandomWeapNum <= 130) {
					if (Commands->Get_Player_Type(sender) == 1) 
						Commands->Give_Powerup(sender,"POW_Chaingun_Player",true);
					else if (Commands->Get_Player_Type(sender) == 0)
						Commands->Give_Powerup(sender,"POW_Chaingun_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Chaingun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 130 && RandomWeapNum <= 140) {
					Commands->Give_Powerup(sender,"POW_RocketLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RocketLauncherWeak", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 140 && RandomWeapNum <= 150) {
					Commands->Give_Powerup(sender,"POW_ChemSprayer_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d ChemSprayer", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 150 && RandomWeapNum <= 160) {
					Commands->Give_Powerup(sender,"POW_TiberiumAutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d TiberiumAutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 160 && RandomWeapNum <= 166) {
					if (Commands->Get_Player_Type(sender) == 1) 
						Commands->Give_Powerup(sender,"POW_SniperRifle_Player",true);
					else if (Commands->Get_Player_Type(sender) == 0)
						Commands->Give_Powerup(sender,"POW_SniperRifle_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d SniperRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 166 && RandomWeapNum <= 172) {	
					Commands->Give_Powerup(sender,"POW_LaserChaingun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d LaserChaingun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 172 && RandomWeapNum <= 178) {
					Commands->Give_Powerup(sender,"POW_LaserRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d LaserRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 178 && RandomWeapNum <= 184) {
					Commands->Give_Powerup(sender,"CnC_POW_RocketLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RocketLauncherStrong", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 184 && RandomWeapNum <= 190) {
					Commands->Give_Powerup(sender,"POW_TiberiumFlechetteGun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d TiberiumFlechetteGun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 190 && RandomWeapNum <= 193) {
					Commands->Give_Powerup(sender,"POW_PersonalIonCannon_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d PersonalIonCannon", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 193 && RandomWeapNum <= 196) {
					Commands->Give_Powerup(sender,"POW_Railgun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Railgun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 196 && RandomWeapNum <= 198) {
					Commands->Give_Powerup(sender,"POW_RamjetRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RamjetRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 198 && RandomWeapNum <= 199) {
					Commands->Give_Powerup(sender,"POW_VoltAutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d VoltAutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 199 && RandomWeapNum <= 200) {
					Commands->Give_Powerup(sender,"CnC_POW_VoltAutoRifle_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d VoltAutoRifle_Nod", Commands->Get_Player_Type(sender));
				}

				else {
					Commands->Give_Powerup(sender,"POW_Pistol_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Pistol", Commands->Get_Player_Type(sender));
				}
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}
			
			//Random Vehicle Crate
			else if (RandomIntCrate > 43 && RandomIntCrate <= 53) {
				GameObject *theVeh;
				Vector3 thePos;
				int RandomVehNum = Commands->Get_Random_Int(1,201);

				if (Commands->Get_Player_Type(sender) == 1) {
					Commands->Set_Position(sender,GDI_Veh_Spawn);
					thePos = GDI_Harv_Spawn;
				}
				else if (Commands->Get_Player_Type(sender) == 0) {
					Commands->Set_Position(sender,Nod_Veh_Spawn);
					thePos = Nod_Harv_Spawn;
				}

				if (RandomVehNum > 0 && RandomVehNum <= 20) {
					theVeh = Commands->Create_Object("CnC_GDI_Humm-vee",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Humm-vee", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 20 && RandomVehNum <= 40) {
					theVeh = Commands->Create_Object("CnC_Nod_Buggy",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Buggy", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 40 && RandomVehNum <= 60) {
					theVeh = Commands->Create_Object("CnC_Civilian_Pickup01_Secret",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Pickup", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 60 && RandomVehNum <= 80) {
					theVeh = Commands->Create_Object("CnC_Civilian_Sedan01_Secret",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Sedan", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 80 && RandomVehNum <= 100) {
					theVeh = Commands->Create_Object("Nod_Chameleon",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Chameleon", Commands->Get_Player_Type(sender));
				}

				else if (RandomVehNum > 100 && RandomVehNum <= 115) {
					theVeh = Commands->Create_Object("CnC_GDI_APC",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_APC", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 115 && RandomVehNum <= 130) {
					theVeh = Commands->Create_Object("CnC_Nod_APC",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_APC", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 130 && RandomVehNum <= 145) {
					theVeh = Commands->Create_Object("CnC_GDI_MRLS",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_MRLS", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 145 && RandomVehNum <= 160) {
					theVeh = Commands->Create_Object("CnC_Nod_Mobile_Artillery",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Mobile_Art", Commands->Get_Player_Type(sender));
				}

				else if (RandomVehNum > 160 && RandomVehNum <= 170) {
					theVeh = Commands->Create_Object("CnC_GDI_Medium_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Medium_Tank", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 170 && RandomVehNum <= 180) {
					theVeh = Commands->Create_Object("CnC_Nod_Light_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Light_Tank", Commands->Get_Player_Type(sender));
				}

				else if (RandomVehNum > 180 && RandomVehNum <= 185) {
					theVeh = Commands->Create_Object("CnC_Nod_Flame_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Flame_Tank", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 185 && RandomVehNum <= 190) {
					theVeh = Commands->Create_Object("CnC_Nod_Stealth_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Stealth_Tank", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 190 && RandomVehNum <= 195) {
					theVeh = Commands->Create_Object("CnC_GDI_Mammoth_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Mammoth_Tank", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 195 && RandomVehNum <= 200) {
					theVeh = Commands->Create_Object("CnC_Nod_Recon_Bike",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Recon", Commands->Get_Player_Type(sender));
				}
				else {
					theVeh = Commands->Create_Object("CnC_GDI_Humm-vee",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Humm-vee", Commands->Get_Player_Type(sender));
				}

				Commands->Set_Player_Type(theVeh,Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Death Crate
			else if (RandomIntCrate > 53 && RandomIntCrate <= 59) {
				Commands->Apply_Damage(sender,99999,"Shrapnel",false);
				sprintf(CrateMessage,"/crateinfo Death_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Tiberium Death and Tiberium Suit Crate
			else if (RandomIntCrate > 59 && RandomIntCrate <= 65) {
				Commands->Apply_Damage(sender,99999,"TiberiumRaw",false);
				Commands->Create_Object("CnC_Visceroid",Commands->Get_Position(sender));
				sprintf(CrateMessage,"/crateinfo Tiberium_Death_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);		
			}

			//Beacon Death and Beacon Crate
			else if (RandomIntCrate > 65 && RandomIntCrate <= 67) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					if (Commands->Get_Player_Type(sender) == 0) {
						GameObject *Beacon_Box = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
						Commands->Attach_Script(Beacon_Box,"KAK_Create_Beacon_Death","0");
						Commands->Create_Object("Beacon_Ion_Cannon_Anim_Pre",Commands->Get_Position(obj));
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d IonCannon", Commands->Get_Player_Type(sender));
					}
					else if (Commands->Get_Player_Type(sender) == 1) {
						GameObject *Beacon_Box = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
						Commands->Attach_Script(Beacon_Box,"KAK_Create_Beacon_Death","1");
						Commands->Create_Object("Beacon_Nuke_Strike_Anim_Pre",Commands->Get_Position(obj));
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d Nuke", Commands->Get_Player_Type(sender));
					}
					else {
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d Null", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					if (Commands->Get_Player_Type(sender) == 1) {
						Commands->Give_Powerup(sender,"CnC_POW_IonCannonBeacon_Player",true);
						sprintf(CrateMessage,"/crateinfo Beacon_Crate %d Ion", Commands->Get_Player_Type(sender));
					}
					else if (Commands->Get_Player_Type(sender) == 0) {
						Commands->Give_Powerup(sender,"CnC_POW_Nuclear_Missle_Beacon",true);
						sprintf(CrateMessage,"/crateinfo Beacon_Crate %d Nuke", Commands->Get_Player_Type(sender));
					}
				}
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);	
			}

			//Full Health and Dehealth Crate
			else if (RandomIntCrate > 67 && RandomIntCrate <= 72) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);

				if (RandomGoodNum == 1) {
					if (Commands->Get_Health(sender) == Commands->Get_Max_Health(sender)) {
						Commands->Give_Powerup(sender,"POW_Medal_Health",true);
					}
					else {
						Commands->Set_Health(sender,Commands->Get_Max_Health(sender));
					}
					sprintf(CrateMessage,"/crateinfo Full_Health_Crate %d", Commands->Get_Player_Type(sender));
				}
				else if (RandomGoodNum == 2) {
					if (Commands->Get_Health(sender) > 1) {
						Commands->Set_Health(sender,1);
					}
					else {
						Commands->Set_Health(sender,Commands->Get_Max_Health(sender));
					}
					sprintf(CrateMessage,"/crateinfo Dehealth_Crate %d", Commands->Get_Player_Type(sender));
				}

				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Full Armor Crate
			else if (RandomIntCrate > 72 && RandomIntCrate <= 77) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);

				if (RandomGoodNum == 1) {
					if (Commands->Get_Shield_Strength(sender) == Commands->Get_Max_Shield_Strength(sender)) {
						Commands->Give_Powerup(sender,"POW_Medal_Armor",true);
					}
					else {
						Commands->Set_Shield_Strength(sender,Commands->Get_Max_Shield_Strength(sender));
					}
					sprintf(CrateMessage,"/crateinfo Full_Armor_Crate %d", Commands->Get_Player_Type(sender));
				}
				else if (RandomGoodNum == 2) {
					if (Commands->Get_Shield_Strength(sender) > 1) {
						Commands->Set_Shield_Strength(sender,1);
					}
					else {
						Commands->Send_Custom_Event(obj,sender,28000,0,0);
					}
					Commands->Set_Shield_Strength(sender,1);
					sprintf(CrateMessage,"/crateinfo Dearmor_Crate %d", Commands->Get_Player_Type(sender));
				}

				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Full Ammo Crate
			else if (RandomIntCrate > 77 && RandomIntCrate <= 82) {
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				sprintf(CrateMessage,"/crateinfo Full_Ammo_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Refill Crate
			else if (RandomIntCrate > 82 && RandomIntCrate <= 84) {
				Commands->Set_Health(sender,Commands->Get_Max_Health(sender));
				Commands->Set_Shield_Strength(sender,Commands->Get_Max_Shield_Strength(sender));
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				sprintf(CrateMessage,"/crateinfo Refill_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Butter Fingers Crate
			else if (RandomIntCrate > 84 && RandomIntCrate <= 87) {
				Commands->Clear_Weapons(sender);

				int RandomBFNum = Commands->Get_Random_Int(1,3);
				if (RandomBFNum == 1) Commands->Give_Powerup(sender,"POW_Pistol_Player",false);
				else if (RandomBFNum == 2) Commands->Give_Powerup(sender,"CnC_POW_MineTimed_Player_01",false);
				else Commands->Give_Powerup(sender,"CnC_POW_MineTimed_Player_01",false);

				sprintf(CrateMessage,"/crateinfo Butter_Fingers_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Kamikaze Suit Crate
			else if (RandomIntCrate > 87 && RandomIntCrate <= 92) {
				Commands->Send_Custom_Event(obj,sender,250000,0,0);
				sprintf(CrateMessage,"/crateinfo KamiKaze_Suit_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1) 
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Spy Crate
			else if (RandomIntCrate > 92 && RandomIntCrate <= 94) {
				Commands->Set_Is_Visible(sender,false);
				sprintf(CrateMessage,"/crateinfo Spy_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Thief Crate
			else if (RandomIntCrate > 94 && RandomIntCrate <= 97) {
				Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
				sprintf(CrateMessage,"/crateinfo Thief_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			//Second Wind Crate
			else if (RandomIntCrate > 97 && RandomIntCrate <= 100) {
				Commands->Send_Custom_Event(obj,sender,260000,0,0);
				sprintf(CrateMessage,"/crateinfo Second_Wind_Crate %d", Commands->Get_Player_Type(sender));
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}

			// Nothing Else
			else {
				sprintf(CrateMessage,"/crateinfo Debug %d %d",RandomIntCrate);
				if (Commands->Get_Player_Type(sender) == 1)
					sprintf(Message2Send,"%s %dGDI",CrateMessage,(int)Commands->Get_Points(sender));
				else if (Commands->Get_Player_Type(sender) == 0)
					sprintf(Message2Send,"%s %dNod",CrateMessage,(int)Commands->Get_Points(sender));

				SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
				SendtoIRC(Message2Send);
			}
		}
	}
}

void M00_CNC_Crate::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {

	}
}

void KAK_Temp_Crate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 990000) {
		IsRepeate = false;
		Commands->Destroy_Object(obj);
	}
}

/* ************************************************************************************************************* */

/*void KAK_Building_Repurchase_Crate::Created(GameObject *obj) {
	//printf("%s death crate created.\n",Get_Parameter("Building"));
}
void KAK_Building_Repurchase_Crate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000025) {
		int PlayerCreds = Commands->Get_Money(sender);
		if (strstr(Get_Parameter("Building"),"mp_Hand_of_Nod")) {
			if (PlayerCreds < 100) {
				HONPool += PlayerCreds;
				Commands->Give_Money(sender,(PlayerCreds * -1),false);
			}
			else {
				if ((HONPool + 100) > 5000) {
					int moneytotake = ((HONPool + 100) - 5000);
					HONPool += moneytotake;
					Commands->Give_Money(sender,(moneytotake * -1),false);
				}
				else {
					HONPool += 100;
					Commands->Give_Money(sender,-100,false);
				}
			}

			char CurrMap[256];
			getProfileString("DSData","CurrMap","null",CurrMap,256,"gimmeurDATAS.dat");
			if (HONPool >= 5000) {
				int HONPool = 0;
				Vector3 NewHONBC;
				NewHONBC.X = (float)getProfileInt(CurrMap,"HONBC_X",0,"gimmeurDATAS.dat");
				NewHONBC.Y = (float)getProfileInt(CurrMap,"HONBC_Y",0,"gimmeurDATAS.dat");
				NewHONBC.Z = (float)getProfileInt(CurrMap,"HONBC_Z",0,"gimmeurDATAS.dat");
				Commands->Create_Object("mp_Hand_of_Nod",NewHONBC);
				GameObject *HONBC = Commands->Find_Object(1551561);
				Commands->Set_Health(HONBC,500);
				Commands->Send_Custom_Event(sender,HONBC,1000000000,0,0);
			}
			else {
				Vector3 DeathCrateLocation;
				DeathCrateLocation.X=(float)getProfileInt(CurrMap,"HONDeathCrate_X",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Y=(float)getProfileInt(CurrMap,"HONDeathCrate_Y",0,"gimmeurDATAS.dat");
				DeathCrateLocation.Z=(float)getProfileInt(CurrMap,"HONDeathCrate_Z",0,"gimmeurDATAS.dat");
				GameObject *deathcrate = Commands->Create_Object("CnC_Ammo_Crate",DeathCrateLocation);
				Commands->Attach_Script(deathcrate,"KAK_Building_Repurchase_Crate","mp_Hand_of_Nod");
			}
		}
	}
}*/

/* ************************************************************************************************************* */

void KAK_Beacon_Log::Created(GameObject *obj) {
	IsDisarmed = false;
	char params[256];
	sprintf(params,"%s",Commands->Get_Preset_Name(obj));
	InvisObjCont = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
	Commands->Attach_Script(InvisObjCont,"KAK_Beacon_Log_CreateControl",params);
}

void KAK_Beacon_Log::Destroyed(GameObject *obj) {
	Commands->Destroy_Object(InvisObjCont);
	if (IsDisarmed == false) {
		if (strstr(Commands->Get_Preset_Name(obj),"CnC_Beacon_IonCannon")) {
			SendtoIRC("/beacon ION detonate");
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Beacon_NukeStrike")) {
			SendtoIRC("/beacon NUKE detonate");
		}
	}
}

void KAK_Beacon_Log::Killed(GameObject *obj, GameObject *shooter) {
	if (IsDisarmed == false) {
		IsDisarmed = true;
		if (strstr(Commands->Get_Preset_Name(obj),"CnC_Beacon_IonCannon")) {
			SendtoIRC("/beacon ION disarm");
			SendtoIRC("/beacon ION interrupt");
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Beacon_NukeStrike")) {
			SendtoIRC("/beacon NUKE disarm");
			SendtoIRC("/beacon NUKE interrupt");
		}
	}
}

void KAK_Beacon_Log_CreateControl::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,3);
}

void KAK_Beacon_Log_CreateControl::Timer_Expired(GameObject *obj, int number) {
	if (number == 3) {
		if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_IonCannon")) {
			SendtoIRC("/beacon ION deploy");
			Commands->Start_Timer(obj,this,5,4);
		}
		else if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_NukeStrike")) {
			SendtoIRC("/beacon NUKE deploy");
			Commands->Start_Timer(obj,this,5,4);
		}
	}
	else if (number == 4) {
		if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_IonCannon")) {
			SendtoIRC("/beacon ION approach");
		}
		else if (strstr(Get_Parameter("Beacon"),"CnC_Beacon_NukeStrike")) {
			SendtoIRC("/beacon NUKE approach");
		}
	}
}

void KAK_Beacon_Animation_Log::Created(GameObject *obj) {
	if (strstr(Commands->Get_Preset_Name(obj),"Beacon_Ion_Cannon_Anim_Pre")) {
		SendtoIRC("/beacon ION initiate");
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"Beacon_Nuke_Strike_Anim_Pre")) {
		SendtoIRC("/beacon NUKE initiate");
	}
}

/* ************************************************************************************************************* */

void KAK_Ped_Beacon_Controller::Created(GameObject *obj) {
	printf("Ped Created\n");
}

void KAK_Ped_Beacon_Controller::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	printf("Ped Custom %d %d %s\n",message,param,Commands->Get_Preset_Name(sender));
}

void KAK_Ped_Beacon_Controller::Entered(GameObject *obj, GameObject *enter) {
	printf("Ped Entered %s\n",Commands->Get_Preset_Name(enter));
}

/* ************************************************************************************************************* */

void KAK_Vehicle_Log::Created(GameObject *obj) {
	char vehmessage[512];
	sprintf(vehmessage,"/vehicle created %s",Commands->Get_Preset_Name(obj));
	SendtoIRC(vehmessage);

	if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_APC")) TotalSeats = 4;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Mammoth_Tank")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_MRLS")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Orca")) TotalSeats = 1;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Transport")) TotalSeats = 4;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Civilian_Pickup01_Secret")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Civilian_Sedan01_Secret")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Apache")) TotalSeats = 1;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_APC")) TotalSeats = 4;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Flame_Tank")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Mobile_Artillery")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Recon_Bike")) TotalSeats = 1;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Stealth_Tank")) TotalSeats = 1;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Transport")) TotalSeats = 4;
	else if (strstr(Commands->Get_Preset_Name(obj),"Nod_Chameleon")) TotalSeats = 2;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester")) TotalSeats = 0;
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) TotalSeats = 0;
	SeatsTaken = 0;
	Seat1 = 0;
	Seat2 = 0;
	Seat3 = 0;
	Seat4 = 0;
	Seat5 = 0;
}
void KAK_Vehicle_Log::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000028) {
		SeatsTaken++;
		//if (SeatsTaken >= TotalSeats) Commands->Enable_HUD_Pokable_Indicator(obj,false);

		if (Seat1 != 0) Seat1 = Commands->Get_ID(sender);
		else if (Seat2 != 0) Seat2 = Commands->Get_ID(sender);
		else if (Seat3 != 0) Seat3 = Commands->Get_ID(sender);
		else if (Seat4 != 0) Seat4 = Commands->Get_ID(sender);
		else if (Seat5 != 0) Seat5 = Commands->Get_ID(sender);
	}
	else if (message == 1000000029) {
		SeatsTaken--;
		//if (SeatsTaken < TotalSeats) Commands->Enable_HUD_Pokable_Indicator(obj,true);

		if (Seat1 == Commands->Get_ID(sender)) Seat1 = 0;
		else if (Seat2 == Commands->Get_ID(sender)) Seat2 = 0;
		else if (Seat3 == Commands->Get_ID(sender)) Seat3 = 0;
		else if (Seat4 == Commands->Get_ID(sender)) Seat4 = 0;
		else if (Seat5 == Commands->Get_ID(sender)) Seat5 = 0;
	}
}

void KAK_Vehicle_Log::Killed(GameObject *obj, GameObject *shooter) {
	char vehmessage[512];
	if (Commands->Get_Player_Type(shooter) == 1)
		sprintf(vehmessage,"/vehicle killed %s %d %dGDI",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Points(shooter));
	else if (Commands->Get_Player_Type(shooter) == 2)
		sprintf(vehmessage,"/vehicle killed %s %d %dNod",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Points(shooter));
	else
		sprintf(vehmessage,"/vehicle killed %s %d",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter));
	SendtoIRC("/wolsend gameopt $readini(%fdsconf, server, nickname) :RGINFO");
	SendtoIRC(vehmessage);

	DeadPlace = Commands->Get_Position(obj);
	Facing = Commands->Get_Facing(obj);

	if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Humm-vee")) {	
		DestroyedTank = Commands->Create_Object("GDI_Humm-vee_destroyed",DeadPlace);
		Commands->Set_Facing(DestroyedTank,Facing);
		Commands->Attach_Script(DestroyedTank,"KAK_Vehicle_Death","1");
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_APC")) {	
		DestroyedTank = Commands->Create_Object("GDI_APC_Destroyed",DeadPlace);
		Commands->Set_Facing(DestroyedTank,Facing);
		Commands->Attach_Script(DestroyedTank,"KAK_Vehicle_Death","1");
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Medium_Tank")) {	
		DestroyedTank = Commands->Create_Object("GDI_Medium_Tank_Destroyed",DeadPlace);
		Commands->Set_Facing(DestroyedTank,Facing);
		Commands->Attach_Script(DestroyedTank,"KAK_Vehicle_Death","1");
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Buggy")) {	
		DestroyedTank = Commands->Create_Object("Nod_Buggy_Destroyed",DeadPlace);
		Commands->Set_Facing(DestroyedTank,Facing);
		Commands->Attach_Script(DestroyedTank,"KAK_Vehicle_Death","1");
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Light_Tank")) {	
		DeadPlace.Z -= (float)1;
		DestroyedTank = Commands->Create_Object("Nod_Light_Tank_Destroyed",DeadPlace);
		Commands->Set_Facing(DestroyedTank,Facing);
		Commands->Attach_Script(DestroyedTank,"KAK_Vehicle_Death","1");
	}
}

void KAK_Vehicle_Death::Created(GameObject *obj) {
	if (Get_Int_Parameter("DisablePhysics") == 1) Commands->Disable_Physical_Collisions(obj);
	else if (Get_Int_Parameter("DisablePhysics") == 0) Commands->Enable_Collisions(obj);
	Commands->Set_Is_Visible(obj,false);
	Commands->Set_Player_Type(obj,2);
	Commands->Set_Shield_Strength(obj,0);
	Commands->Set_Health(obj,50);
	//Commands->Start_Timer(obj,this,60,4);
}

void KAK_Vehicle_Death::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (damage < 0) {
		if (Commands->Get_Health(obj) == Commands->Get_Max_Health(obj) && Commands->Get_Shield_Strength(obj) == Commands->Get_Max_Shield_Strength(obj)) {
			DeadPlace = Commands->Get_Position(obj);
			Facing = Commands->Get_Facing(obj);

			if (strstr(Commands->Get_Preset_Name(obj),"GDI_Humm-vee_destroyed")) {	
				DestroyedTank = Commands->Create_Object("CnC_GDI_Humm-vee",DeadPlace);
				Commands->Set_Facing(DestroyedTank,Facing);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"GDI_APC_Destroyed")) {	
				DestroyedTank = Commands->Create_Object("CnC_GDI_APC",DeadPlace);
				Commands->Set_Facing(DestroyedTank,Facing);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"GDI_Medium_Tank_Destroyed")) {	
				DestroyedTank = Commands->Create_Object("CnC_GDI_Medium_Tank",DeadPlace);
				Commands->Set_Facing(DestroyedTank,Facing);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"Nod_Buggy_Destroyed")) {	
				DestroyedTank = Commands->Create_Object("CnC_Nod_Buggy",DeadPlace);
				Commands->Set_Facing(DestroyedTank,Facing);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"Nod_Light_Tank_Destroyed")) {	
				DeadPlace.Z += (float)1;
				DestroyedTank = Commands->Create_Object("CnC_Nod_Light_Tank",DeadPlace);
				Commands->Set_Facing(DestroyedTank,Facing);
			}
			Commands->Destroy_Object(obj);
			Commands->Set_Player_Type(DestroyedTank,Commands->Get_Player_Type(damager));
		}
	}
}

void KAK_Vehicle_Death::Timer_Expired(GameObject *obj, int number) {
	if (number == 4) Commands->Destroy_Object(obj);
}

/* ************************************************************************************************************* */

void KAK_Random_Weather::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,1,0);
	LastWeather = -1;
}

void KAK_Random_Weather::Timer_Expired(GameObject *obj, int number) {
	if (number == 0) {
		//RandomWeather
		char MapName[256], IDNum[10];
		sprintf(IDNum,"%d",Get_Int_Parameter("BarrID"));
		getProfileString("Map",IDNum,"Null",MapName,256,"gimmeurDATAS.dat");

		int WeatherSevere = Commands->Get_Random_Int(0,14);
		if (WeatherSevere >= 0 && WeatherSevere < 5) WeatherSevere = 0;
		else if (WeatherSevere >= 6 && WeatherSevere < 9) WeatherSevere = 1;
		else if (WeatherSevere == 9 || WeatherSevere == 10) WeatherSevere = 2;
		else if (WeatherSevere == 11) WeatherSevere = 3;
		else if (WeatherSevere == 12) WeatherSevere = 4;
		else if (WeatherSevere == 13) WeatherSevere = 5;

		Commands->Set_Fog_Enable(true);
		Commands->Set_Fog_Range(10.0f,10.0f,true);

		if (strstr(MapName,"C&C_Under.mix") || strstr(MapName,"C&C_Conquest_Winter.mix")) {
			if (WeatherSevere > 3) WeatherSevere = 3;

			if (WeatherSevere == 1) {
				Commands->Set_Snow(0.3f,0.3f,true);
				Commands->Set_Clouds(0.3f,0.3f,true);
				Commands->Set_Wind(0.0,0.5,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Snow Light");
			}
			else if (WeatherSevere == 2) {
				Commands->Set_Snow(0.7f,0.7f,true);
				Commands->Set_Clouds(0.6f,0.6f,true);
				Commands->Set_Wind(0.0,2.0,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Snow Moderate");
			}
			else if (WeatherSevere == 3) {
				Commands->Set_Snow(1.0f,1.0f,true);
				Commands->Set_Clouds(1.0f,1.0f,true);
				Commands->Set_Wind(0.0,4.0,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Snow Severe");
			}
			else if (WeatherSevere == 0) {
				Commands->Set_Snow(0.0f,0.0f,true);
				Commands->Set_Clouds(0.0f,0.0f,true);
				Commands->Set_Wind(0.0,0.0,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather normal");
			}
			LastWeather = WeatherSevere;
		}
		else if (strstr(MapName,"C&C_Volcano.mix")) {
			if (WeatherSevere > 2) WeatherSevere = 2;

			if (WeatherSevere == 1) {
				Commands->Set_Ash(0.5f,0.5f,true);
				Commands->Set_Clouds(0.5f,0.5f,true);
				Commands->Set_Wind(0.0,0.5,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Ash Light");
			}
			else if (WeatherSevere == 2) {
				Commands->Set_Ash(1.0f,1.0f,true);
				Commands->Set_Clouds(1.0f,1.0f,true);
				Commands->Set_Wind(0.0,3.5,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Ash Severe");
			}
			else if (WeatherSevere == 0) {
				Commands->Set_Ash(0.0f,0.0f,true);
				Commands->Set_Clouds(0.0f,0.0f,true);
				Commands->Set_Wind(0.0,0.0,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather normal");
			}
			LastWeather = WeatherSevere;
		}
		else {
			if (WeatherSevere == 1) {
				Commands->Set_Rain(1.5f,1.5f,true);
				Commands->Set_Clouds(0.15f,0.15f,true);
				Commands->Set_Lightning(0.0f,0,1,0,1,true);
				Commands->Set_Wind(0.0,0.25,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Rain Light");
			}
			else if (WeatherSevere == 2) {
				Commands->Set_Rain(3.0f,3.0f,true);
				Commands->Set_Clouds(0.3f,0.3f,true);
				Commands->Set_Lightning(0.0f,0,1,0,1,true);
				Commands->Set_Wind(0.0,0.5,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Rain Heavy_Light");
			}
			else if (WeatherSevere == 3) {
				Commands->Set_Rain(5.0f,5.0f,true);
				Commands->Set_Clouds(0.65f,0.65f,true);
				Commands->Set_Lightning(0.0f,0,1,0,1,true);
				Commands->Set_Wind(0.0,1.0,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Rain Moderate");
			}
			else if (WeatherSevere == 4) {
				Commands->Set_Rain(7.5f,7.5f,true);
				Commands->Set_Lightning(0.8f,0,1,0,1,true);
				Commands->Set_Clouds(0.5f,0.5f,true);
				Commands->Set_Wind(0.0,3.5,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Rain Heavy_Moderate");
			}
			else if (WeatherSevere == 5) {
				Commands->Set_Rain(10.0f,10.0f,true);
				Commands->Set_Lightning(1.0f,0,1,0,1,true);
				Commands->Set_Clouds(1.0f,1.0f,true);
				Commands->Set_Wind(0.0,5.0,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather Rain Severe");
			}
			else if (WeatherSevere == 0) {
				Commands->Set_Rain(0.0f,0.0f,true);
				Commands->Set_Lightning(0.0f,0,1,0,1,true);
				Commands->Set_Clouds(0.0f,0.0f,true);
				Commands->Set_Wind(0.0,0.0,1.0,true);
				if (WeatherSevere != LastWeather) SendtoIRC("/weather normal");
			}
			LastWeather = WeatherSevere;
		}

		Commands->Start_Timer(obj,this,Commands->Get_Random(60,300),0);
	}
}

/* ************************************************************************************************************* */

void KAK_Create_Beacon_Death::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,10,1);
}

void KAK_Create_Beacon_Death::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		if (Get_Int_Parameter("Team") == 0) {
			Commands->Create_Object("Beacon_Ion_Cannon_Anim_Post",Commands->Get_Position(obj));
			Commands->Create_Explosion("Explosion_IonCannonBeacon",Commands->Get_Position(obj),0);
		}
		else if (Get_Int_Parameter("Team") == 1) {
			Commands->Create_Object("Beacon_Nuke_Strike_Anim_Post",Commands->Get_Position(obj));
			Commands->Create_Explosion("Explosion_NukeBeacon",Commands->Get_Position(obj),0);
		}
		Commands->Destroy_Object(obj);
	}
}

/* ************************************************************************************************************* */

void KAK_Tiberium_Zone::Created(GameObject *obj) {
	printf("Ped Created %d\n",Get_Int_Parameter("Team"));
}

void KAK_Tiberium_Zone::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	printf("Ped Custom %d %d %s\n",message,param,Commands->Get_Preset_Name(sender));
}

void KAK_Tiberium_Zone::Entered(GameObject *obj, GameObject *enter) {
	printf("Ped Entered %s\n",Commands->Get_Preset_Name(enter));
}

/* ************************************************************************************************************* */

ScriptRegistrant<M00_BUILDING_EXPLODE_NO_DAMAGE_DAK> M00_BUILDING_EXPLODE_NO_DAMAGE_DAK_Registrant("M00_BUILDING_EXPLODE_NO_DAMAGE_DAK","");
ScriptRegistrant<M00_Disable_Transition> M00_Disable_Transition_Registrant("M00_Disable_Transition","");
ScriptRegistrant<M00_GrantPowerup_Created> M00_GrantPowerup_Created_Registrant("M00_GrantPowerup_Created","WeaponDef:string");
ScriptRegistrant<KAK_Backpack> KAK_Backpack_Registrant("KAK_Backpack","");
ScriptRegistrant<KAK_Backpack_Object> KAK_Backpack_Object_Registrant("KAK_Backpack_Object","CharacterType:string");
ScriptRegistrant<M00_CNC_Crate> M00_CNC_Crate_Registrant("M00_CNC_Crate","");
ScriptRegistrant<KAK_Temp_Crate> KAK_Temp_Crate_Registrant("KAK_Temp_Crate","");
ScriptRegistrant<KAK_Rebuy_BD> KAK_Rebuy_BD_Registrant("KAK_Rebuy_BD","PlayerType:int,BDNum:int");
ScriptRegistrant<KAK_Rebuy_Box> KAK_Rebuy_Box_Registrant("KAK_Rebuy_Box","PlayerType:int,BDName:string");
//ScriptRegistrant<KAK_Building_Repurchase_Crate> KAK_Building_Repurchase_Crate_Registrant("KAK_Building_Repurchase_Crate","Building:string");
ScriptRegistrant<KAK_Beacon_Log> KAK_Beacon_Log_Registrant("KAK_Beacon_Log","");
ScriptRegistrant<KAK_Beacon_Log_CreateControl> KAK_Beacon_Log_CreateControl_Registrant("KAK_Beacon_Log_CreateControl","Beacon:string");
ScriptRegistrant<KAK_Beacon_Animation_Log> KAK_Beacon_Animation_Log_Registrant("KAK_Beacon_Animation_Log","");
ScriptRegistrant<KAK_Vehicle_Log> KAK_Vehicle_Log_Registrant("KAK_Vehicle_Log","");
ScriptRegistrant<KAK_Vehicle_Death> KAK_Vehicle_Death_Registrant("KAK_Vehicle_Death","DisablePhysics:int");
ScriptRegistrant<KAK_Ped_Beacon_Controller> KAK_Ped_Beacon_Controller_Registrant("KAK_Ped_Beacon_Controller","");
ScriptRegistrant<KAK_Random_Weather> KAK_Random_Weather_Registrant("KAK_Random_Weather","BarrID:int");
ScriptRegistrant<KAK_Create_Beacon_Death> KAK_Create_Beacon_Death_Registrant("KAK_Create_Beacon_Death","Team:int");
ScriptRegistrant<KAK_Tiberium_Zone> KAK_Tiberium_Zone_Registrant("KAK_Tiberium_Zone","Team:int");