#define BONE_HEAD 0
#define BONE_NECK 1
#define BONE_LCLAVICLE 2
#define BONE_RCLAVICLE 3
#define BONE_LUPPERARM 4
#define BONE_RUPPERARM 5
#define BONE_LFOREARM 6
#define BONE_RFOREARM 7
#define BONE_LHAND 8
#define BONE_RHAND 9
#define BONE_USPINE 10
#define BONE_DSPINE 11
#define BONE_PELVIS 12
#define BONE_LTHIGH 13
#define BONE_RTHIGH 14
#define BONE_LCALF 15
#define BONE_RCALF 16
#define BONE_LFOOT 17
#define BONE_RFOOT 18
#define BONE_BACKGUN 19
#define BONE_BACKPOUCH 20

class M00_BUILDING_EXPLODE_NO_DAMAGE_DAK : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed(GameObject * obj,GameObject * shooter);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Destroyed(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	int totalbuildings;
	char buildingID[100];
	char buildingPosX[50];
	char buildingPosY[50];
	char buildingPosZ[50];
	char totalbuildings_string[100];
	char newtotalbuildings_string[100];
	FILE *f;
	float TotalHealth;
	int IntHealth;
};

class M00_Disable_Transition : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	int totalbuildings;
	char buildingID[100];
	char buildingPosX[50];
	char buildingPosY[50];
	char buildingPosZ[50];
	char totalbuildings_string[100];
	char newtotalbuildings_string[100];
	FILE *f;
	float TotalHealth;
	int IntHealth;
	Vector3 HarvyPos;
};

class M00_GrantPowerup_Created : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	void Timer_Expired(GameObject *obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Destroyed(GameObject *obj);
	GameObject *BackpackObject;
	GameObject *BackpackScript;
	Vector3 DeathPlace;
	bool IsKamiKaze;
	bool IsSecondWind;
	bool IsTibSuit;
	bool FullKill;
	Vector3 SpawnPos;
	int AfkDetect;
	bool DidEvent;
};	

class KAK_Backpack : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	char GunToGive[512];
	int SpawnedByID;
};

class KAK_Backpack_Object : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	GameObject *BackpackScript;
	Vector3 DeathPlace;
};

class M00_CNC_Crate : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
	int RandomIntCrate;
	char CrateMessage[512];
	char Message2Send[512];
	GameObject *vehBlocker;
};

class KAK_Temp_Crate : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};

class KAK_Rebuy_BD : public ScriptImpClass {
	void Killed(GameObject *obj, GameObject *shooter);
};
class KAK_Rebuy_Box : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
};


/*class KAK_Building_Repurchase_Crate : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};*/

class KAK_Beacon_Log : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	bool IsDisarmed;
	GameObject *InvisObjCont;
};

class KAK_Beacon_Animation_Log : public ScriptImpClass {
	void Created(GameObject *obj);
};

class KAK_Beacon_Log_CreateControl : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Vehicle_Log : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Destroyed(GameObject *obj);

	Vector3 DeadPlace;
	float Facing;
};

class KAK_Vehicle_Death : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Timer_Expired(GameObject *obj, int number);
	int MaxHealth, CurrHealth;
	GameObject *DestroyedTank;
	Vector3 DeadPlace;
	float Facing;
};

class KAK_Ped_Beacon_Controller : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Entered(GameObject *obj, GameObject *enter);
};

class KAK_Random_Weather : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	float Range, CurrentClouds, CurrentRain, CurrentLightning, CurrentSnow, CurrentAsh, CurrentWind;
	char MapName[256], IDNum[10];
};

class KAK_Random_Weather2 : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	//float Range, CurrentClouds, CurrentRain, CurrentLightning, CurrentSnow, CurrentAsh, CurrentWind;
	float CloudCover, CloudGloominess, Heading, PrecepDensity, WindSpeed, WindVariability;
	float CoverRange, GloomRange, HeadRange, WindVarRange;
	char MapName[256], IDNum[10];
};

class KAK_Create_Beacon_Death : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Regen_Health : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Buffer_DIAG : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Veteran_System : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed(GameObject *obj, GameObject *killer);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	float DamagePoints, SentDamagePoints;
	int KillPoints, SentKillPoints, SentRepairPoints;
};

class KAK_Powerup_Stealth_Suit : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Parachute_Vehicle : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Destroyed(GameObject *obj);
	int Seat1, Seat2, Seat3, Seat4;
};

class KAK_Parachute : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Timer_Expired(GameObject *obj, int number);

	GameObject *Parachute;
	float NewZ, LastZ;
};

class KAK_ConsoleCommand : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Manual_Crate : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	GameObject *Crate;
	Vector3 thePos;
};

class KAK_Manual_Crate_Respawner : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};

class KAK_Spectator_Mode : public ScriptImpClass {
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	int OriginalTeam;
};

class KAK_Lock_Vehicle : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Created(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
};

class KAK_Flash_Object : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	int TotalLoops;
	GameObject *Object;
};

class KAK_Regen_Custom : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};

class KAK_Freeze_Object : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	float ElapsedTime;
	Vector3 OriginalPos;
};

class KAK_Obelisk_Powerup : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
	GameObject *Powerup;
	bool IsPowerup;
	int LastID, ObGlitchCount;
};

class KAK_Destroy_Tank : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Grow_Crystal : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	int Cry1, Cry2, Cry3, Cry4, Cry5, Cry6, Cry7, Cry8, Cry9, Cry0;
	char MapName[256], IDNum[10], crys1[20], crys2[20], crys3[20], crys4[20], crys5[20], crys6[20], crys7[20], crys8[20], crys9[20], crys0[20];
};

class KAK_Vehicle_Damage : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	bool IsFirstShow, IsSecondShow;
	float TotalHealth, CurrentHealth;
	GameObject *Fire1, *Fire2, *Fire3, *Fire4, *Explosion1, *Explosion2;
	int Size, FireCount;
};

class KAK_Convert_Visceroid : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Killed(GameObject *obj, GameObject *shooter);
};

class KAK_Prevent_Destruction_Until_Entered : public ScriptImpClass {
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Crystal_Harvest_Grow : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	float Interval;
	GameObject *Crystal;
	Vector3 CryPos;
};

class KAK_Crystal_Harvest_Idle : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	GameObject *TibGas;
};

class KAK_Crystal_Harvest_Holder : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	GameObject *TibGas, *Crystal;
};

class KAK_Power_Crate_Revert : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};