#include "stdafx.h"
#include "scripts.h"
#include "kak.h"
#include "PROFILE.h"
#include <stdio.h>
#include <windows.h>
#include <process.h>
#include <fstream>
#include <iostream.h>
#include <string>
#include <stdlib.h>
#include "ddeml.h"
#include <sys/stat.h>

bool Created_Nod_Veh_Zone = false;
bool Created_GDI_Veh_Zone = false;
bool IsRepeate = false;
bool IsCrateCreated = false;
Vector3 GDI_Veh_Spawn;
Vector3 Nod_Veh_Spawn;
Vector3 GDI_Harv_Spawn;
Vector3 Nod_Harv_Spawn;

HDDEDATA CALLBACK DdeCallback(
    UINT uType,
    UINT uFmt,
    HCONV hconv,
    HSZ hsz1,
    HSZ hsz2,
    HDDEDATA hdata,
    DWORD dwData1,
    DWORD dwData2)
{
    return 0;
}

void DDEPoke(DWORD idInst, HCONV hConv, char* szData)
{
    HSZ hszItem = DdeCreateStringHandle(idInst, "command", 0);
	DdeClientTransaction((LPBYTE)szData, (DWORD)(lstrlen(szData)+1),
                          hConv, hszItem, CF_TEXT,
                          XTYP_POKE, 3000, NULL);
    DdeFreeStringHandle(idInst, hszItem);
}

int SendtoIRC (char* message)
{
	char szApp[20];
    getProfileString("Settings", "DDEName", "null", szApp, 20, "Scripts.ini");
    char szTopic[] = "COMMAND";

    DWORD idInst=0;
    UINT iReturn;
    iReturn = DdeInitialize(&idInst, (PFNCALLBACK)DdeCallback, 
                            APPCLASS_STANDARD | APPCMD_CLIENTONLY, 0 );
    if (iReturn!=DMLERR_NO_ERROR)
    {
        return 1;
    }

    HSZ hszApp, hszTopic;
    HCONV hConv;
    hszApp = DdeCreateStringHandle(idInst, szApp, 0);
    hszTopic = DdeCreateStringHandle(idInst, szTopic, 0);
    hConv = DdeConnect(idInst, hszApp, hszTopic, NULL);
    DdeFreeStringHandle(idInst, hszApp);
    DdeFreeStringHandle(idInst, hszTopic);
    if (hConv == NULL)
    {
        DdeUninitialize(idInst);
        return 2;
    }

    DDEPoke(idInst, hConv, message);
    DdeDisconnect(hConv);
    DdeUninitialize(idInst);

    return 0;
}

void CreateFDS (const char* Preset, int IntHealth) {
	if (strstr(Preset,"mp_Nod_Obelisk")) {
		printf("Nod Obelisk Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"Nod_Turret_MP")) {
		printf("Nod Turret Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"Nod_Turret_MP_Improved")) {
		printf("Nod Turret Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Nod_Power_Plant")) {
		printf("Nod Power Plant Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Nod_Refinery")) {
		printf("Nod Tiberium Refinery Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Nod_Tiberium_Silo")) {
		printf("Nod Tiberium Silo Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Hand_of_Nod")) {
		printf("Hand of Nod Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Nod_Airstrip")) {
		printf("Nod Airstrip Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Nod_Repair_Bay")) {
		printf("Nod Repair Facility Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Nod_Repair_Facility")) {
		printf("GDI Repair Facility Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"MP_Nod_ConstructionYard")) {
		printf("Nod Construction Yard Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Nod_Helipad")) {
		printf("Nod Helipad Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_Nod_Com_Center")) {
		printf("Nod Communications Center Online %d/%d\n",IntHealth,IntHealth);
	}

	else if (strstr(Preset,"mp_GDI_Advanced_Guard_Tower")) {
		printf("GDI Advanced Guard Tower Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"GDI_Guard_Tower")) {
		printf("GDI Guard Tower Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_Power_Plant")) {
		printf("GDI Power Plant Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_Refinery")) {
		printf("GDI Tiberium Refinery Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_Tiberium_Silo")) {
		printf("GDI Tiberium Silo Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_Barracks")) {
		printf("GDI Barracks Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_War_Factory")) {
		printf("GDI Weapons Factory Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_Repair_Bay")) {
		printf("GDI Repair Facility Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_Repair_Facility")) {
		printf("GDI Repair Facility Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"MP_GDI_ConstructionYard")) {
		printf("GDI Construction Yard Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_Helipad")) {
		printf("GDI Helipad Online %d/%d\n",IntHealth,IntHealth);
	}
	else if (strstr(Preset,"mp_GDI_Com_Center")) {
		printf("GDI Communications Center Online %d/%d\n",IntHealth,IntHealth);
	}

	else if (strstr(Preset,"CnC_GDI_Harvester")) {
		printf("GDI Tiberium Harvester Created\n");
	}
	else if (strstr(Preset,"CnC_Nod_Harvester")) {
		printf("Nod Tiberium Harvester Created\n");
	}
}

void KilledFDS (const char* Preset) {
	if (strstr(Preset,"mp_Nod_Obelisk")) {
		printf("Nod Obelisk Destroyed\n");
	}
	else if (strstr(Preset,"Nod_Turret_MP")) {
		printf("Nod Turret Destroyed\n");
	}
	else if (strstr(Preset,"Nod_Turret_MP_Improved")) {
		printf("Nod Turret Destroyed\n");
	}
	else if (strstr(Preset,"mp_Nod_Power_Plant")) {
		printf("Nod Power Plant Destroyed\n");
	}
	else if (strstr(Preset,"mp_Nod_Refinery")) {
		printf("Nod Tiberium Refinery Destroyed\n");
	}
	else if (strstr(Preset,"mp_Nod_Tiberium_Silo")) {
		printf("Nod Tiberium Silo Destroyed\n");
	}
	else if (strstr(Preset,"mp_Hand_of_Nod")) {
		printf("Hand of Nod Destroyed\n");
	}
	else if (strstr(Preset,"mp_Nod_Airstrip")) {
		printf("Nod Airstrip Destroyed\n");
	}
	else if (strstr(Preset,"mp_Nod_Repair_Bay")) {
		printf("Nod Repair Facility Destroyed\n");
	}
	else if (strstr(Preset,"mp_Nod_Repair_Facility")) {
		printf("Nod Repair Facility Destroyed\n");
	}
	else if (strstr(Preset,"MP_Nod_ConstructionYard")) {
		printf("Nod Construction Yard Destroyed\n");
	}
	else if (strstr(Preset,"mp_Nod_Helipad")) {
		printf("Nod Helipad Destroyed\n");
	}
	else if (strstr(Preset,"mp_Nod_Com_Center")) {
		printf("Nod Communications Center Destroyed\n");
	}

	else if (strstr(Preset,"mp_GDI_Advanced_Guard_Tower")) {
		printf("GDI Advanced Guard Tower Destroyed\n");
	}
	else if (strstr(Preset,"GDI_Guard_Tower")) {
		printf("GDI Guard Tower Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_Power_Plant")) {
		printf("GDI Power Plant Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_Refinery")) {
		printf("GDI Tiberium Refinery Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_Tiberium_Silo")) {
		printf("GDI Tiberium Silo Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_Barracks")) {
		printf("GDI Infantry Barracks Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_War_Factory")) {
		printf("GDI Weapons Factory Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_Repair_Bay")) {
		printf("GDI Repair Facility Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_Repair_Facility")) {
		printf("GDI Repair Facility Destroyed\n");
	}
	else if (strstr(Preset,"MP_GDI_ConstructionYard")) {
		printf("GDI Construction Yard Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_Helipad")) {
		printf("GDI Helipad Destroyed\n");
	}
	else if (strstr(Preset,"mp_GDI_Com_Center")) {
		printf("GDI Communications Center Destroyed\n");
	}

	else if (strstr(Preset,"CnC_GDI_Harvester")) {
		printf("GDI Tiberium Harvester Destroyed\n");
	}
	else if (strstr(Preset,"CnC_Nod_Harvester")) {
		printf("Nod Tiberium Harvester Destroyed\n");
	}
}


/* ************************************************************************************************************* */


void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Created(GameObject *obj) {
	TotalHealth = Commands->Get_Health(obj);
	IntHealth = (int)TotalHealth;
	char Health[256];
	sprintf(Health,"/bhealth %s %d None %d",Commands->Get_Preset_Name(obj),IntHealth,(int)Commands->Get_Max_Health(obj));
	SendtoIRC(Health);

	/*totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
	sprintf(buildingID,"%d",Commands->Get_ID(obj));
	sprintf(buildingPosX,"%f",Commands->Get_Position(obj).X);
	sprintf(buildingPosY,"%f",Commands->Get_Position(obj).Y);
	sprintf(buildingPosZ,"%f",Commands->Get_Position(obj).Z);
	sprintf(totalbuildings_string,"%d",totalbuildings);
	sprintf(newtotalbuildings_string,"%d",(totalbuildings + 1));

	writeProfileString("Buildings","TotalAmount",newtotalbuildings_string,"IDNum.dat");
	writeProfileString("Buildings",totalbuildings_string,buildingID,"IDNum.dat");
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Power_Plant")) writeProfileString("Buildings","GDIPP",buildingID,"IDNum.dat");
	else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Power_Plant")) writeProfileString("Buildings","NodPP",buildingID,"IDNum.dat");
	writeProfileString(buildingID,"Name",Commands->Get_Preset_Name(obj),"IDNum.dat");
	writeProfileString(buildingID,"PositionX",buildingPosX,"IDNum.dat");
	writeProfileString(buildingID,"PositionY",buildingPosY,"IDNum.dat");
	writeProfileString(buildingID,"PositionZ",buildingPosZ,"IDNum.dat");*/

	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
		Created_Nod_Veh_Zone = false;
		Created_GDI_Veh_Zone = false;
		IsRepeate = false;
		IsCrateCreated = false;
	}

	CreateFDS(Commands->Get_Preset_Name(obj),IntHealth);
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Damaged(GameObject *obj, GameObject *damager, float damage)
{
	static bool Sent500 = true;
	TotalHealth -= damage;
	if ((int)TotalHealth <= (IntHealth - 10)) {
		Sent500 = false;
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
	else if ((int)TotalHealth >= (IntHealth + 10)) {
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
	else if ((int)TotalHealth == 500 && Sent500 == false) {
		Sent500 = true;
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Killed(GameObject * obj,GameObject * shooter)
{
	char Health[256];
	sprintf(Health,"/bdead %s %d %d",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Max_Health(obj));
	SendtoIRC(Health);

	/*char numbertolook[100];
	char IDtolook[100];
	char WhatIDIs[100];
	totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
	for (int i = 0; i < totalbuildings; i++) {
		sprintf(numbertolook,"%d",i);
		sprintf(IDtolook,"%d",Commands->Get_ID(obj));
		getProfileString("Buildings",numbertolook,"null",WhatIDIs,100,"IDNum.dat");
		if (strstr(WhatIDIs,IDtolook)) writeProfileString("Buildings",numbertolook,"dead","IDNum.dat");
	}
	if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Power_Plant"))
		writeProfileString("Buildings","GDIPP","dead","IDNum.dat");
	else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Power_Plant"))
		writeProfileString("Buildings","NodPP","dead","IDNum.dat");*/

	KilledFDS(Commands->Get_Preset_Name(obj));
}


void M00_Disable_Transition::Created(GameObject *obj) {
	TotalHealth = Commands->Get_Health(obj);
	IntHealth = (int)TotalHealth;
	char Health[256];
	sprintf(Health,"/bhealth %s %d None %d",Commands->Get_Preset_Name(obj),IntHealth,(int)Commands->Get_Max_Health(obj));
	SendtoIRC(Health);

	if (strstr(Commands->Get_Preset_Name(obj),"Nod_Turret_MP")) {
		if (!strstr(Commands->Get_Preset_Name(obj),"_Improved")) {
			Commands->Destroy_Object(obj);
			Commands->Create_Object("Nod_Turret_MP_Improved",Commands->Get_Position(obj));
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"_Improved")) {
			Commands->Attach_Script(obj,"M00_Vehicle_Regen_DAK","");
			CreateFDS(Commands->Get_Preset_Name(obj),IntHealth);
			/*totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
			sprintf(buildingID,"%d",Commands->Get_ID(obj));
			sprintf(buildingPosX,"%f",Commands->Get_Position(obj).X);
			sprintf(buildingPosY,"%f",Commands->Get_Position(obj).Y);
			sprintf(buildingPosZ,"%f",Commands->Get_Position(obj).Z);
			sprintf(totalbuildings_string,"%d",totalbuildings);
			sprintf(newtotalbuildings_string,"%d",(totalbuildings + 1));

			writeProfileString("Buildings","TotalAmount",newtotalbuildings_string,"IDNum.dat");
			writeProfileString("Buildings",totalbuildings_string,buildingID,"IDNum.dat");
			if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Power_Plant")) writeProfileString("Buildings","GDIPP",buildingID,"IDNum.dat");
			else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Power_Plant")) writeProfileString("Buildings","NodPP",buildingID,"IDNum.dat");
			writeProfileString(buildingID,"Name",Commands->Get_Preset_Name(obj),"IDNum.dat");
			writeProfileString(buildingID,"PositionX",buildingPosX,"IDNum.dat");
			writeProfileString(buildingID,"PositionY",buildingPosY,"IDNum.dat");
			writeProfileString(buildingID,"PositionZ",buildingPosZ,"IDNum.dat");*/
		}
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"GDI_Guard_Tower")) {
		Commands->Attach_Script(obj,"M00_Vehicle_Regen_DAK","");
		CreateFDS(Commands->Get_Preset_Name(obj),IntHealth);
		/*totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
		sprintf(buildingID,"%d",Commands->Get_ID(obj));
		sprintf(buildingPosX,"%f",Commands->Get_Position(obj).X);
		sprintf(buildingPosY,"%f",Commands->Get_Position(obj).Y);
		sprintf(buildingPosZ,"%f",Commands->Get_Position(obj).Z);
		sprintf(totalbuildings_string,"%d",totalbuildings);
		sprintf(newtotalbuildings_string,"%d",(totalbuildings + 1));

		writeProfileString("Buildings","TotalAmount",newtotalbuildings_string,"IDNum.dat");
		writeProfileString("Buildings",totalbuildings_string,buildingID,"IDNum.dat");
		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Power_Plant")) writeProfileString("Buildings","GDIPP",buildingID,"IDNum.dat");
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Power_Plant")) writeProfileString("Buildings","NodPP",buildingID,"IDNum.dat");
		writeProfileString(buildingID,"Name",Commands->Get_Preset_Name(obj),"IDNum.dat");
		writeProfileString(buildingID,"PositionX",buildingPosX,"IDNum.dat");
		writeProfileString(buildingID,"PositionY",buildingPosY,"IDNum.dat");
		writeProfileString(buildingID,"PositionZ",buildingPosZ,"IDNum.dat");*/
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Harvester")) {
		if (Created_Nod_Veh_Zone == false) {
			Created_Nod_Veh_Zone = true;
			Nod_Veh_Spawn.X = 0;
			Nod_Veh_Spawn.Y = 0;
			Nod_Veh_Spawn.Z = 0;
			HarvyPos.X = 0;
			HarvyPos.Y = 0;
			HarvyPos.Z = 0;
			Commands->Start_Timer(obj,this,10,1);
			CreateFDS(Commands->Get_Preset_Name(obj),IntHealth);
		}
	}
	else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_Harvester")) {
		if (Created_GDI_Veh_Zone == false) {
			Created_GDI_Veh_Zone = true;
			GDI_Veh_Spawn.X = 0;
			GDI_Veh_Spawn.Y = 0;
			GDI_Veh_Spawn.Z = 0;
			HarvyPos.X = 0;
			HarvyPos.Y = 0;
			HarvyPos.Z = 0;
			Commands->Start_Timer(obj,this,4,0);
			CreateFDS(Commands->Get_Preset_Name(obj),IntHealth);
		}
	}
	else {
		CreateFDS(Commands->Get_Preset_Name(obj),IntHealth);
	}
}
void M00_Disable_Transition::Timer_Expired(GameObject *obj,int number) {
	HarvyPos = Commands->Get_Position(obj);
	if (number == 0) {
		//GDI_Veh_Spawn.X = HarvyPos.X - 9.387122;
		//GDI_Veh_Spawn.Y = HarvyPos.Y - -9.048721;
		//GDI_Veh_Spawn.Z = HarvyPos.Z - 1.649353;
		GDI_Veh_Spawn = HarvyPos;
		GDI_Harv_Spawn = HarvyPos;
	}
	else if (number == 1) {
		//Nod_Veh_Spawn.X = HarvyPos.X - -2.974614;
		//Nod_Veh_Spawn.Y = HarvyPos.Y - 19.334434;
		//Nod_Veh_Spawn.Z = HarvyPos.Z - 2.919515;
		Nod_Veh_Spawn = HarvyPos;
		Nod_Harv_Spawn = HarvyPos;
	}
}

void M00_Disable_Transition::Damaged(GameObject *obj, GameObject *damager, float damage)
{
	static bool Sent500 = true;
	TotalHealth -= damage;
	if ((int)TotalHealth <= (IntHealth - 10)) {
		Sent500 = false;
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
	else if ((int)TotalHealth >= (IntHealth + 10)) {
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
	else if ((int)TotalHealth == 500 && Sent500 == false) {
		Sent500 = true;
		IntHealth = (int)TotalHealth;
		char Health[256];
		sprintf(Health,"/bhealth %s %d %d %d",Commands->Get_Preset_Name(obj),IntHealth,Commands->Get_ID(damager),(int)Commands->Get_Max_Health(obj));
		SendtoIRC(Health);
	}
}

void M00_Disable_Transition::Killed(GameObject * obj,GameObject * shooter)
{
	char Health[256];
	sprintf(Health,"/bdead %s %d %d",Commands->Get_Preset_Name(obj),Commands->Get_ID(shooter),(int)Commands->Get_Max_Health(obj));
	SendtoIRC(Health);

	if (strstr(Commands->Get_Preset_Name(obj),"Nod_Turret_MP_Improved")) {
		Commands->Create_Object("Nod_Turret_Destroyed",Commands->Get_Position(obj));
		/*char numbertolook[100];
		char IDtolook[100];
		char WhatIDIs[100];
		totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
		for (int i = 0; i < totalbuildings; i++) {
			sprintf(numbertolook,"%d",i);
			sprintf(IDtolook,"%d",Commands->Get_ID(obj));
			getProfileString("Buildings",numbertolook,"null",WhatIDIs,100,"IDNum.dat");
			if (strstr(WhatIDIs,IDtolook)) writeProfileString("Buildings",numbertolook,"dead","IDNum.dat");
		}*/
	}

	else if (strstr(Commands->Get_Preset_Name(obj),"GDI_Guard_Tower")) {
		/*char numbertolook[100];
		char IDtolook[100];
		char WhatIDIs[100];
		totalbuildings = getProfileInt("Buildings","TotalAmount",0,"IDNum.dat");
		for (int i = 0; i < totalbuildings; i++) {
			sprintf(numbertolook,"%d",i);
			sprintf(IDtolook,"%d",Commands->Get_ID(obj));
			getProfileString("Buildings",numbertolook,"null",WhatIDIs,100,"IDNum.dat");
			if (strstr(WhatIDIs,IDtolook)) writeProfileString("Buildings",numbertolook,"dead","IDNum.dat");
		}*/
	}

	KilledFDS(Commands->Get_Preset_Name(obj));
}

void M00_GrantPowerup_Created::Created(GameObject *obj)
{
	//Commands->Create_Object_At_Bone(obj,Get_Parameter("WeaponDef"),"muzzle");
	Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),false);
	IsKamiKaze = false;
}
void M00_GrantPowerup_Created::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (IsSecondWind == true) {
		if (Commands->Get_Health(obj) <= 25) {
			if (Commands->Get_Player_Type(obj) == 1) {
				Commands->Set_Position(obj,GDI_Veh_Spawn);
			}
			else if (Commands->Get_Player_Type(obj) == 0) {
				Commands->Set_Position(obj,Nod_Veh_Spawn);
			}
			IsSecondWind = false;
		}
	}
}
void M00_GrantPowerup_Created::Killed(GameObject *obj, GameObject *shooter) {
	if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
		DeathPlace = Commands->Get_Position(obj);

		if (IsKamiKaze == true) {
			for (int i = 0; i < 16; i++) {
				Commands->Create_Explosion("Explosion_Mine_Remote_01",DeathPlace,0);
			}
		}

		BackpackObject = Commands->Create_Object("Invisible_Object",DeathPlace);
		Commands->Attach_Script(BackpackObject,"KAK_Backpack_Object",Commands->Get_Preset_Name(obj));
	}
}
void M00_GrantPowerup_Created::Timer_Expired(GameObject *obj, int number) {
	if (number == 0) {
		BackpackObject = Commands->Create_Object("POW_Health_025",DeathPlace);
		Commands->Attach_Script(BackpackObject,"M00_Powerup_Destroy","");
	}
	else if (number == 1) {
		BackpackObject = Commands->Create_Object("POW_Armor_025",DeathPlace);
		Commands->Attach_Script(BackpackObject,"M00_Powerup_Destroy","");
	}
}
void M00_GrantPowerup_Created::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 250000) {
		IsKamiKaze = true;
	}
	else if (message == 260000) {
		IsSecondWind = true;
	}
}

void KAK_Backpack_Object::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,1);
}

void KAK_Backpack_Object::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		DeathPlace = Commands->Get_Position(obj);

		int RandomNum = Commands->Get_Random_Int(1,4);

		if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,0,0);
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_MiniGunner_0")) {
			BackpackScript = Commands->Create_Object("POW_AutoRifle_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,1,0);
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_MiniGunner_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_Chaingun_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,3,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_ChemSprayer_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,4,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_0")) {
			BackpackScript = Commands->Create_Object("POW_Flamethrower_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,5,0);
		}

		else if (strstr(Get_Parameter("CharacterType"),"POW_Armor_025")) {
			BackpackScript = Commands->Create_Object("POW_GrenadeLauncher_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,6,0);
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserChaingun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,8,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_LaserRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,9,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Technician_0")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,18,0);
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_RepairGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,18,0);
			}
			else if (RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,11,0);
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Engineer_0")) {
			BackpackScript = Commands->Create_Object("CnC_POW_MineRemote_02",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,11,0);
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney_PowerSuit")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_PersonalIonCannon_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,14,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_Railgun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,16,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,17,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,17,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,20,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_1Off")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,20,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("CnC_POW_RocketLauncher_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,21,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,22,0);
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_0")) {
			BackpackScript = Commands->Create_Object("POW_Shotgun_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,22,0);
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,23,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,24,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney")) {
			if (RandomNum == 1 || RandomNum == 2 || RandomNum == 3) {
				BackpackScript = Commands->Create_Object("POW_TiberiumAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,25,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,24,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_Grenadier_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_TiberiumFlechetteGun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,26,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Ignatio_Mobius")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_VoltAutoRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,27,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_FlameThrower_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("CnC_POW_VoltAutoRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,28,0);
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
				//Commands->Send_Custom_Event(obj,BackpackScript,5000,2,0);
			}
		}

		else {
			BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			//Commands->Send_Custom_Event(obj,BackpackScript,5000,15,0);
		}

		Commands->Send_Custom_Event(obj,BackpackScript,6000,Commands->Get_ID(obj),0);
	}
}

void KAK_Backpack::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 5000) {
		switch (param) {
			case 0:{
				strcpy(GunToGive,"CnC_POW_AutoRifle_Player_GDI");
				break;
			}
			case 1:{
				strcpy(GunToGive,"CnC_POW_AutoRifle_Player_Nod");
				break;
			}
			case 2:{
				strcpy(GunToGive,"POW_Chaingun_Player");
				break;
			}
			case 3:{
				strcpy(GunToGive,"POW_Chaingun_Player_Nod");
				break;
			}
			case 4:{
				strcpy(GunToGive,"POW_ChemSprayer_Player");
				break;
			}
			case 5:{
				strcpy(GunToGive,"POW_Flamethrower_Player");
				break;
			}
			case 6:{
				strcpy(GunToGive,"POW_GrenadeLauncher_Player");
				break;
			}
			case 7:{
				strcpy(GunToGive,"CnC_POW_IonCannonBeacon_Player");
				break;
			}
			case 8:{
				strcpy(GunToGive,"POW_LaserChaingun_Player");
				break;
			}
			case 9:{
				strcpy(GunToGive,"POW_LaserRifle_Player");
				break;
			}
			case 10:{
				strcpy(GunToGive,"CnC_MineProximity_05");
				break;
			}
			case 11:{
				strcpy(GunToGive,"CnC_POW_MineRemote_02");
				break;
			}
			case 12:{
				strcpy(GunToGive,"CnC_POW_MineTimed_Player_01");
				break;
			}
			case 13:{
				strcpy(GunToGive,"CnC_POW_Nuclear_Missle_Beacon");
				break;
			}
			case 14:{
				strcpy(GunToGive,"POW_PersonalIonCannon_Player");
				break;
			}
			case 15:{
				strcpy(GunToGive,"POW_Pistol_Player");
				break;
			}
			case 16:{
				strcpy(GunToGive,"POW_Railgun_Player");
				break;
			}
			case 17:{
				strcpy(GunToGive,"POW_RamjetRifle_Player");
				break;
			}
			case 18:{
				strcpy(GunToGive,"POW_RepairGun_Player");
				break;
			}
			case 19:{
				strcpy(GunToGive,"POW_RepairGun_ai");
				break;
			}
			case 20:{
				strcpy(GunToGive,"POW_RocketLauncher_Player");
				break;
			}
			case 21:{
				strcpy(GunToGive,"CnC_POW_RocketLauncher_Player");
				break;
			}
			case 22:{
				strcpy(GunToGive,"POW_Shotgun_Player");
				break;
			}
			case 23:{
				strcpy(GunToGive,"POW_SniperRifle_Player");
				break;
			}
			case 24:{
				strcpy(GunToGive,"POW_SniperRifle_Player_Nod");
				break;
			}
			case 25:{
				strcpy(GunToGive,"POW_TiberiumAutoRifle_Player");
				break;
			}
			case 26:{
				strcpy(GunToGive,"POW_TiberiumFlechetteGun_Player");
				break;
			}
			case 27:{
				strcpy(GunToGive,"POW_VoltAutoRifle_Player");
				break;
			}
			case 28:{
				strcpy(GunToGive,"CnC_POW_VoltAutoRifle_Player_Nod");
				break;
			}
			default:{
				strcpy(GunToGive,"");
				break;
			}
		}
	}

	else if (message == 6000) {
		SpawnedByID = param;
	}

	else if (message == 1000000025) {
		if (SpawnedByID != Commands->Get_ID(sender)) {
			Commands->Create_Object_At_Bone(obj,GunToGive,"muzzle");
			Commands->Destroy_Object(obj);
		}
	}

}

void M00_CNC_Crate::Created(GameObject *obj) {
	if (IsCrateCreated == false) {
		vehBlocker = Commands->Create_Object("Vehicle_Blocker",Commands->Get_Position(obj));
		IsCrateCreated = true;
	}
}
void M00_CNC_Crate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000025) {
		if (IsRepeate == false) {
			IsRepeate = true;
			Commands->Destroy_Object(vehBlocker);
			IsCrateCreated = false;
			GameObject *tempObj = Commands->Create_Object("Invisible_Object",Commands->Get_Position(obj));
			Commands->Attach_Script(tempObj,"KAK_Temp_Crate","");
			Commands->Send_Custom_Event(sender,tempObj,990000,0,1);
			RandomIntCrate = Commands->Get_Random_Int(1,101);

			// Points and Depoints Crate
			if (RandomIntCrate > 0 && RandomIntCrate <= 14) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Points(sender,1000,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 1000", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Points(sender,500,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Points(sender,250,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Points(sender,100,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Points(sender,100,false);
						sprintf(CrateMessage,"/crateinfo Points_Crate %d 100", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Points(sender,-1000,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 1000", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Points(sender,-500,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Points(sender,-250,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Points(sender,-100,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Points(sender,-100,false);
						sprintf(CrateMessage,"/crateinfo Depoints_Crate %d 100", Commands->Get_Player_Type(sender));
					}
				}
				SendtoIRC(CrateMessage);
			}

		
			//Money and Demoney Crate
			else if (RandomIntCrate > 14 && RandomIntCrate <= 28) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Money(sender,1000,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 1000", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Money(sender,500,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Money(sender,250,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Money(sender,100,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Money(sender,100,false);
						sprintf(CrateMessage,"/crateinfo Money_Crate %d 100", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					int RandomPointNum = Commands->Get_Random_Int(1,11);
					if (RandomPointNum == 10) {
						Commands->Give_Money(sender,-1000,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 1000", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 9 || RandomPointNum == 8) {
						Commands->Give_Money(sender,-500,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 500", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum == 7 || RandomPointNum == 6 || RandomPointNum == 5) {
						Commands->Give_Money(sender,-250,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 250", Commands->Get_Player_Type(sender));
					}
					else if (RandomPointNum < 5) {
						Commands->Give_Money(sender,-100,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Give_Money(sender,-100,false);
						sprintf(CrateMessage,"/crateinfo Demoney_Crate %d 100", Commands->Get_Player_Type(sender));
					}
					if (Commands->Get_Money(sender) < 0) Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
				}
				SendtoIRC(CrateMessage);
			}

			//Random Weapon Crate
			else if (RandomIntCrate > 28 && RandomIntCrate <= 38) {
				int RandomWeapNum = Commands->Get_Random_Int(1,201);
				if (RandomWeapNum > 0 && RandomWeapNum <= 20) {
					Commands->Give_Powerup(sender,"POW_AutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d AutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 20 && RandomWeapNum <= 40) {
					Commands->Give_Powerup(sender,"POW_Shotgun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Shotgun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 40 && RandomWeapNum <= 60) {
					Commands->Give_Powerup(sender,"POW_Flamethrower_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Flamethrower", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 60 && RandomWeapNum <= 80) {
					Commands->Give_Powerup(sender,"POW_GrenadeLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d GrenadeLauncher", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 80 && RandomWeapNum <= 100) {
					Commands->Give_Powerup(sender,"POW_RepairGun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RepairGunWeak", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 100 && RandomWeapNum <= 120) {
					Commands->Give_Powerup(sender,"CnC_POW_MineRemote_02",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RemoteMine2", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 120 && RandomWeapNum <= 130) {
					if (Commands->Get_Player_Type(sender) == 1) 
						Commands->Give_Powerup(sender,"POW_Chaingun_Player",true);
					else if (Commands->Get_Player_Type(sender) == 0)
						Commands->Give_Powerup(sender,"POW_Chaingun_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Chaingun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 130 && RandomWeapNum <= 140) {
					Commands->Give_Powerup(sender,"POW_RocketLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RocketLauncherWeak", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 140 && RandomWeapNum <= 150) {
					Commands->Give_Powerup(sender,"POW_ChemSprayer_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d ChemSprayer", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 150 && RandomWeapNum <= 160) {
					Commands->Give_Powerup(sender,"POW_TiberiumAutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d TiberiumAutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 160 && RandomWeapNum <= 166) {
					if (Commands->Get_Player_Type(sender) == 1) 
						Commands->Give_Powerup(sender,"POW_SniperRifle_Player",true);
					else if (Commands->Get_Player_Type(sender) == 0)
						Commands->Give_Powerup(sender,"POW_SniperRifle_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d SniperRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 166 && RandomWeapNum <= 172) {	
					Commands->Give_Powerup(sender,"POW_LaserChaingun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d LaserChaingun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 172 && RandomWeapNum <= 178) {
					Commands->Give_Powerup(sender,"POW_LaserRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d LaserRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 178 && RandomWeapNum <= 184) {
					Commands->Give_Powerup(sender,"CnC_POW_RocketLauncher_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RocketLauncherStrong", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 184 && RandomWeapNum <= 190) {
					Commands->Give_Powerup(sender,"POW_TiberiumFlechetteGun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d TiberiumFlechetteGun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 190 && RandomWeapNum <= 193) {
					Commands->Give_Powerup(sender,"POW_PersonalIonCannon_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d PersonalIonCannon", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 193 && RandomWeapNum <= 196) {
					Commands->Give_Powerup(sender,"POW_Railgun_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Railgun", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 196 && RandomWeapNum <= 198) {
					Commands->Give_Powerup(sender,"POW_RamjetRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d RamjetRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 198 && RandomWeapNum <= 199) {
					Commands->Give_Powerup(sender,"POW_VoltAutoRifle_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d VoltAutoRifle", Commands->Get_Player_Type(sender));
				}

				else if (RandomWeapNum > 199 && RandomWeapNum <= 200) {
					Commands->Give_Powerup(sender,"CnC_POW_VoltAutoRifle_Player_Nod",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d VoltAutoRifle_Nod", Commands->Get_Player_Type(sender));
				}

				else {
					Commands->Give_Powerup(sender,"POW_Pistol_Player",true);
					sprintf(CrateMessage,"/crateinfo Random_Weapon_Crate %d Pistol", Commands->Get_Player_Type(sender));
				}
				SendtoIRC(CrateMessage);
			}

			//Random Vehicle Crate
			else if (RandomIntCrate > 38 && RandomIntCrate <= 47) {
				GameObject *theVeh;
				Vector3 thePos;
				int RandomVehNum = Commands->Get_Random_Int(1,201);

				if (Commands->Get_Player_Type(sender) == 1) {
					Commands->Set_Position(sender,GDI_Veh_Spawn);
					thePos = GDI_Harv_Spawn;
				}
				else if (Commands->Get_Player_Type(sender) == 0) {
					Commands->Set_Position(sender,Nod_Veh_Spawn);
					thePos = Nod_Harv_Spawn;
				}

				if (RandomVehNum > 0 && RandomVehNum <= 20) {
					theVeh = Commands->Create_Object("CnC_GDI_Humm-vee",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Humm-vee", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 20 && RandomVehNum <= 40) {
					theVeh = Commands->Create_Object("CnC_Nod_Buggy",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Buggy", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 40 && RandomVehNum <= 60) {
					theVeh = Commands->Create_Object("CnC_Civilian_Pickup01_Secret",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Pickup", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 60 && RandomVehNum <= 80) {
					theVeh = Commands->Create_Object("CnC_Civilian_Sedan01_Secret",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Sedan", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 80 && RandomVehNum <= 100) {
					theVeh = Commands->Create_Object("Nod_Chameleon",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Chameleon", Commands->Get_Player_Type(sender));
				}

				else if (RandomVehNum > 100 && RandomVehNum <= 115) {
					theVeh = Commands->Create_Object("CnC_GDI_APC",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_APC", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 115 && RandomVehNum <= 130) {
					theVeh = Commands->Create_Object("CnC_Nod_APC",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_APC", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 130 && RandomVehNum <= 145) {
					theVeh = Commands->Create_Object("CnC_GDI_MRLS",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_MRLS", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 145 && RandomVehNum <= 160) {
					theVeh = Commands->Create_Object("CnC_Nod_Mobile_Artillery",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Mobile_Art", Commands->Get_Player_Type(sender));
				}

				else if (RandomVehNum > 160 && RandomVehNum <= 170) {
					theVeh = Commands->Create_Object("CnC_GDI_Medium_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Medium_Tank", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 170 && RandomVehNum <= 180) {
					theVeh = Commands->Create_Object("CnC_Nod_Light_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Light_Tank", Commands->Get_Player_Type(sender));
				}

				else if (RandomVehNum > 180 && RandomVehNum <= 185) {
					theVeh = Commands->Create_Object("CnC_Nod_Flame_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Flame_Tank", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 185 && RandomVehNum <= 190) {
					theVeh = Commands->Create_Object("CnC_Nod_Stealth_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Stealth_Tank", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 190 && RandomVehNum <= 195) {
					theVeh = Commands->Create_Object("CnC_GDI_Mammoth_Tank",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Mammoth_Tank", Commands->Get_Player_Type(sender));
				}
				else if (RandomVehNum > 195 && RandomVehNum <= 200) {
					theVeh = Commands->Create_Object("CnC_Nod_Recon_Bike",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d Nod_Recon", Commands->Get_Player_Type(sender));
				}
				else {
					theVeh = Commands->Create_Object("CnC_GDI_Humm-vee",thePos);
					sprintf(CrateMessage,"/crateinfo Random_Vehicle_Crate %d GDI_Humm-vee", Commands->Get_Player_Type(sender));
				}

				Commands->Set_Player_Type(theVeh,Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Death Crate
			else if (RandomIntCrate > 47 && RandomIntCrate <= 56) {
				Commands->Apply_Damage(sender,99999,"Shrapnel",false);
				sprintf(CrateMessage,"/crateinfo Death_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Tiberium Death and Tiberium Suit Crate
			else if (RandomIntCrate > 56 && RandomIntCrate <= 65) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					Commands->Apply_Damage(sender,99999,"TiberiumRaw",false);
					sprintf(CrateMessage,"/crateinfo Tiberium_Death_Crate %d", Commands->Get_Player_Type(sender));
				}
				else if (RandomGoodNum == 2) {
					Commands->Set_Shield_Type(sender,"ShieldChemWarrior");
					sprintf(CrateMessage,"/crateinfo Tiberium_Suit_Crate %d", Commands->Get_Player_Type(sender));
				}
				SendtoIRC(CrateMessage);		
			}

			//Beacon Death and Beacon Crate
			else if (RandomIntCrate > 65 && RandomIntCrate <= 67) {
				int RandomGoodNum = Commands->Get_Random_Int(1,3);
				if (RandomGoodNum == 1) {
					int RandomSWNum = Commands->Get_Random_Int(1,3);
					if (RandomSWNum == 1) {
						Commands->Apply_Damage(sender,99999,"IonCannon",false);
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d IonCannon", Commands->Get_Player_Type(sender));
					}
					else if (RandomSWNum == 2) {
						Commands->Apply_Damage(sender,99999,"Nuke",false);
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d Nuke", Commands->Get_Player_Type(sender));
					}
					else {
						Commands->Apply_Damage(sender,99999,"Nuke",false);
						sprintf(CrateMessage,"/crateinfo Beacon_Death_Crate %d Nuke", Commands->Get_Player_Type(sender));
					}
				}
				else if (RandomGoodNum == 2) {
					if (Commands->Get_Player_Type(sender) == 1) {
						Commands->Give_Powerup(sender,"CnC_POW_IonCannonBeacon_Player",true);
						sprintf(CrateMessage,"/crateinfo Beacon_Crate %d Ion", Commands->Get_Player_Type(sender));
					}
					else if (Commands->Get_Player_Type(sender) == 0) {
						Commands->Give_Powerup(sender,"CnC_POW_Nuclear_Missle_Beacon",true);
						sprintf(CrateMessage,"/crateinfo Beacon_Crate %d Nuke", Commands->Get_Player_Type(sender));
					}
				}
				SendtoIRC(CrateMessage);	
			}

			//Full Health and Dehealth Crate
			else if (RandomIntCrate > 67 && RandomIntCrate <= 72) {
				int RandomGoodNum = Commands->Get_Random_Int(1,4);
				if (RandomGoodNum == 1 || RandomGoodNum == 2) {
					Commands->Set_Health(sender,Commands->Get_Max_Health(sender));
					sprintf(CrateMessage,"/crateinfo Full_Health_Crate %d", Commands->Get_Player_Type(sender));
				}
				else if (RandomGoodNum == 3) {
					Commands->Set_Health(sender,1);
					sprintf(CrateMessage,"/crateinfo Dehealth_Crate %d", Commands->Get_Player_Type(sender));
				}
				SendtoIRC(CrateMessage);
			}

			//Full Armor Crate
			else if (RandomIntCrate > 72 && RandomIntCrate <= 77) {
				int RandomGoodNum = Commands->Get_Random_Int(1,4);
				if (RandomGoodNum == 1 || RandomGoodNum == 2) {
					Commands->Set_Shield_Strength(sender,Commands->Get_Max_Shield_Strength(sender));
					sprintf(CrateMessage,"/crateinfo Full_Armor_Crate %d", Commands->Get_Player_Type(sender));
				}
				else if (RandomGoodNum == 3) {
					Commands->Set_Shield_Strength(sender,1);
					sprintf(CrateMessage,"/crateinfo Dearmor_Crate %d", Commands->Get_Player_Type(sender));
				}
				SendtoIRC(CrateMessage);
			}

			//Full Ammo Crate
			else if (RandomIntCrate > 77 && RandomIntCrate <= 82) {
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				sprintf(CrateMessage,"/crateinfo Full_Ammo_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Refill Crate
			else if (RandomIntCrate > 82 && RandomIntCrate <= 84) {
				Commands->Set_Health(sender,Commands->Get_Max_Health(sender));
				Commands->Set_Shield_Strength(sender,Commands->Get_Max_Shield_Strength(sender));
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				Commands->Give_Powerup(sender,"CnC_POW_Ammo_ClipMax",false);
				sprintf(CrateMessage,"/crateinfo Refill_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Butter Fingers Crate
			else if (RandomIntCrate > 84 && RandomIntCrate <= 87) {
				Commands->Clear_Weapons(sender);

				int RandomBFNum = Commands->Get_Random_Int(1,3);
				if (RandomBFNum == 1) Commands->Give_Powerup(sender,"POW_Pistol_Player",false);
				else if (RandomBFNum == 2) Commands->Give_Powerup(sender,"CnC_POW_MineTimed_Player_01",false);
				else Commands->Give_Powerup(sender,"CnC_POW_MineTimed_Player_01",false);

				sprintf(CrateMessage,"/crateinfo Butter_Fingers_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Kamikaze Suit Crate
			else if (RandomIntCrate > 87 && RandomIntCrate <= 92) {
				Commands->Send_Custom_Event(obj,sender,250000,0,0);
				sprintf(CrateMessage,"/crateinfo KamiKaze_Suit_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Spy Crate
			else if (RandomIntCrate > 92 && RandomIntCrate <= 94) {
				Commands->Set_Is_Visible(sender,false);
				sprintf(CrateMessage,"/crateinfo Spy_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Thief Crate
			else if (RandomIntCrate > 94 && RandomIntCrate <= 97) {
				Commands->Give_Money(sender,(Commands->Get_Money(sender) * -1),false);
				sprintf(CrateMessage,"/crateinfo Thief_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			//Second Wind Crate
			else if (RandomIntCrate > 97 && RandomIntCrate <= 100) {
				Commands->Send_Custom_Event(obj,sender,260000,0,0);
				sprintf(CrateMessage,"/crateinfo Second_Wind_Crate %d", Commands->Get_Player_Type(sender));
				SendtoIRC(CrateMessage);
			}

			// Nothing Else
			else {
				sprintf(CrateMessage,"/crateinfo Debug %d %d",RandomIntCrate);
				SendtoIRC(CrateMessage);
			}
		}
	}
}
void M00_CNC_Crate::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {

	}
}

void KAK_Temp_Crate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 990000) {
		IsRepeate = false;
		Commands->Destroy_Object(obj);
	}
}


ScriptRegistrant<M00_BUILDING_EXPLODE_NO_DAMAGE_DAK> M00_BUILDING_EXPLODE_NO_DAMAGE_DAK_Registrant("M00_BUILDING_EXPLODE_NO_DAMAGE_DAK","");
ScriptRegistrant<M00_Disable_Transition> M00_Disable_Transition_Registrant("M00_Disable_Transition","");
ScriptRegistrant<M00_GrantPowerup_Created> M00_GrantPowerup_Created_Registrant("M00_GrantPowerup_Created","WeaponDef:string");
ScriptRegistrant<KAK_Backpack> KAK_Backpack_Registrant("KAK_Backpack","");
ScriptRegistrant<KAK_Backpack_Object> KAK_Backpack_Object_Registrant("KAK_Backpack_Object","CharacterType:string");
ScriptRegistrant<M00_CNC_Crate> M00_CNC_Crate_Registrant("M00_CNC_Crate","");
ScriptRegistrant<KAK_Temp_Crate> KAK_Temp_Crate_Registrant("KAK_Temp_Crate","");
