#include "stdafx.h"
#include "scripts.h"
ScriptFactory::ScriptFactory(char *n,char *p)
{ 
	name = n;
	params = p;
	next = 0;
	temp = 0;
	ScriptRegistrar::RegisterScript(this);
}
ScriptFactory *ScriptFactory::GetNext()
{
	return next;
}
char *ScriptFactory::GetName()
{
	return name;
}
char *ScriptFactory::GetParamDescription()
{
	return params;
}
ScriptFactory::~ScriptFactory()
{
	if(temp) {
		ScriptRegistrar::UnregisterScript(this);
		name = 0;
		params = 0;
	} else {
		temp = 1;
	}
}
void ScriptFactory::SetNext(ScriptFactory *ptr)
{
	if (next)
		ptr->SetNext(next);
	next = ptr;
}
