#include "stdafx.h"
#include "scripts.h"
#include "kak.h"
#include "PROFILE.h"

/* ******************************************************************************************************** */

bool ShowStartMessage = false;
int SnipeMode = getProfileInt("Settings","EnableSnipeMode",0,"SnipeMode.ini");
int IgnoreBaseDefense = getProfileInt("Settings","IgnoreBaseDefense",0,"SnipeMode.ini");
int AllowPistol = getProfileInt("Settings","AllowPistol",0,"SnipeMode.ini");
int KillHS = getProfileInt("Settings","KillRamjet",0,"SnipeMode.ini");
int KillRB = getProfileInt("Settings","KillPICBolt",0,"SnipeMode.ini");
int MoneytoGive = getProfileInt("Settings","CreditsOnSpawn",99999,"SnipeMode.ini");
int DropWeapons = getProfileInt("Settings","DropWeapons",0,"SnipeMode.ini");
int LogInfDeath = getProfileInt("Settings","LogInfDeath",0,"SnipeMode.ini");
int KillSB = getProfileInt("Settings","KillSoldierBuilding",1,"SnipeMode.ini");
bool fixMoney = false;
bool KilledWF = false;
bool KilledAir = false;
bool KilledBarr = false;
bool KilledHON = false;
int WFID = 0;
int AirID = 0;
int BarrID = 0;
int HONID = 0;
bool Is_First_Game = true;

/* ******************************************************************************************************** */

void LogMessageInfDeath (const char* Message) {
	renremdate.refreshdate();
	char FDSlogname[100];
	sprintf(FDSlogname, "killlog_%s.txt",renremdate.get_date_string());

	std::ofstream FDSLog (FDSlogname,ios::app);
	if (FDSLog.is_open()) {
		char messageprint[512];
		char hours[5];
		char mins[5];
		char secs[5];
		time_t rawtime;
		struct tm *timeinfo;
		time(&rawtime);
		timeinfo = localtime(&rawtime);

		int hour = timeinfo->tm_hour;
		int min = timeinfo->tm_min;
		int sec = timeinfo->tm_sec;
		if (hour < 10) sprintf(hours,"0%d",hour);
		else sprintf(hours,"%d",hour);
		if (min < 10) sprintf(mins,"0%d",min);
		else sprintf(mins,"%d",min);
		if (sec < 10) sprintf(secs,"0%d",sec);
		else sprintf(secs,"%d",sec);

		sprintf(messageprint,"[%s:%s:%s] %s\n",hours,mins,secs,Message);
		FDSLog << messageprint;
		FDSLog.close();
	}
}

/* ******************************************************************************************************** */

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Created(GameObject *obj) {
	if (SnipeMode == 1) {
		if (fixMoney == false) {
			fixMoney = true;
			if (MoneytoGive < 1000 || MoneytoGive > 99999) MoneytoGive = 1000;
		}

		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_War_Factory")) {
			KilledWF = false;
			WFID = Commands->Get_ID(obj);
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Airstrip")) {
			KilledAir = false;
			AirID = Commands->Get_ID(obj);
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Hand_of_Nod") && KillSB == 1) {
			KilledHON = false;
			HONID = Commands->Get_ID(obj);
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks") && KillSB == 1) {
			KilledBarr = false;
			BarrID = Commands->Get_ID(obj);
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}

		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
			rename("data\\objects.ddb","data\\bjects.ddb");
			if (Is_First_Game == true) {
				ConsoleCommand("gameover");
				Is_First_Game = false;
			}
			else if (ShowStartMessage == false) {
				ShowStartMessage = true;
				ConsoleCommand("msg This server is running the Server Sniper Mod.");
				if (IgnoreBaseDefense == 1) printf("Base Defenses will ignore all players.\n");
				else printf("Base Defenses will fire at all players.\n");
				if (AllowPistol == 1) printf("Pistols are allowed.\n");
				else printf("Pistols are not allowed.\n");
				if (KillHS == 0) printf("Havoc/Sakura are allowed.\n");
				else printf("Havoc/Sakura are NOT allowed.\n");
				if (KillRB == 0) printf("PIC Sydney/Raveshaw are allowed.\n");
				else printf("PIC Sydney/Raveshaw are NOT allowed.\n");
				printf("Credits given on death set to %d.\n",MoneytoGive);
				if (DropWeapons == 1) printf("Weapons will drop from fallen soldiers.\n");
				else printf("Weapons will not drop from fallen soldiers.\n");
				if (LogInfDeath == 1) printf("Infantry death will be logged.\n");
				else printf("Infantry death will not be logged.\n");
				if (KillSB == 1) printf("Infantry Buildings will be killed.\n");
				else printf("Infantry Buildings will NOT be killed.\n");
			}
		}
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Killed(GameObject *obj, GameObject *shooter) {
	if (SnipeMode == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_War_Factory")) {
			KilledWF = true;
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Airstrip")) {
			KilledAir = true;
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Hand_of_Nod") && KillSB == 1) {
			KilledHON = true;
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks") && KillSB == 1) {
			KilledBarr = true;
		}
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (SnipeMode == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_War_Factory")) {
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Airstrip")) {
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Hand_of_Nod") && KillSB == 1) {
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks") && KillSB == 1) {
			Commands->Apply_Damage(obj,99999,"Explosive",false);
		}
		else {
			if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,damage,false);
				Commands->Give_Money(damager,(damage * (float)-1),false);
			}
			else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
				Commands->Give_Points(damager,(damage * (float)-1),false);
				Commands->Give_Money(damager,(damage * (float)-1),false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,damage,false);
				Commands->Give_Money(damager,(damage * (float)-1),false);
			}
			else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
				Commands->Give_Points(damager,(damage * (float)-1),false);
				Commands->Give_Money(damager,(damage * (float)-1),false);
			}


			if (damage >= 500) {
				if (Commands->Get_Player_Type(damager) == 1 && strstr(Commands->Get_Preset_Name(obj),"GDI")) {
					Commands->Give_Points(damager,(float)250,false);
					Commands->Give_Money(damager,(float)-250,false);
				}
				else if (Commands->Get_Player_Type(damager) == 1 && !strstr(Commands->Get_Preset_Name(obj),"GDI")) {
					Commands->Give_Points(damager,(float)-250,false);
					Commands->Give_Money(damager,(float)-250,false);
				}
				else if (Commands->Get_Player_Type(damager) == 0 && strstr(Commands->Get_Preset_Name(obj),"Nod")) {
					Commands->Give_Points(damager,(float)250,false);
					Commands->Give_Money(damager,(float)-250,false);
				}
				else if (Commands->Get_Player_Type(damager) == 0 && !strstr(Commands->Get_Preset_Name(obj),"Nod")) {
					Commands->Give_Points(damager,(float)-250,false);
					Commands->Give_Money(damager,(float)-250,false);
				}
			}

			Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
		}
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Destroyed(GameObject *obj) {
	if (SnipeMode == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_War_Factory")) {
			KilledWF = true;
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Nod_Airstrip")) {
			KilledAir = true;
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_Hand_of_Nod") && KillSB == 1) {
			KilledHON = true;
		}
		else if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks") && KillSB == 1) {
			KilledBarr = true;
		}

		if (strstr(Commands->Get_Preset_Name(obj),"mp_GDI_Barracks")) {
			rename("data\\bjects.ddb","data\\objects.ddb");
			SnipeMode = getProfileInt("Settings","EnableSnipeMode",0,"SnipeMode.ini");
			IgnoreBaseDefense = getProfileInt("Settings","IgnoreBaseDefense",0,"SnipeMode.ini");
			AllowPistol = getProfileInt("Settings","AllowPistol",0,"SnipeMode.ini");
			KillHS = getProfileInt("Settings","KillRamjet",0,"SnipeMode.ini");
			KillRB = getProfileInt("Settings","KillPICBolt",0,"SnipeMode.ini");
			MoneytoGive = getProfileInt("Settings","CreditsOnSpawn",99999,"SnipeMode.ini");
			DropWeapons = getProfileInt("Settings","DropWeapons",0,"SnipeMode.ini");
			LogInfDeath = getProfileInt("Settings","LogInfDeath",0,"SnipeMode.ini");
			KillSB = getProfileInt("Settings","KillSoldierBuilding",1,"SnipeMode.ini");
			ShowStartMessage = false;
		}
	}
}

/* ******************************************************************************************************** */

void M00_Disable_Transition::Created(GameObject *obj) {
	if (SnipeMode == 1) {
		if (strstr(Commands->Get_Preset_Name(obj),"Turret")) Commands->Destroy_Object(obj);
		if (strstr(Commands->Get_Preset_Name(obj),"Guard_Tower")) Commands->Destroy_Object(obj);

		if (fixMoney == false) {
			fixMoney = true;
			if (MoneytoGive < 0 || MoneytoGive > 99999) MoneytoGive = 99999;
		}

		if (KilledWF == false) {
			Commands->Apply_Damage(Commands->Find_Object(WFID),99999,"Explosive",false);
		}
		if (KilledAir == false) {
			Commands->Apply_Damage(Commands->Find_Object(AirID),99999,"Explosive",false);
		}
		if (KilledBarr == false && KillSB == 1) {
			Commands->Apply_Damage(Commands->Find_Object(BarrID),99999,"Explosive",false);
		}
		if (KilledHON == false && KillSB == 1) {
			Commands->Apply_Damage(Commands->Find_Object(HONID),99999,"Explosive",false);
		}
	}

}

void M00_Disable_Transition::Damaged(GameObject *obj, GameObject *damager, float damage) {
	if (SnipeMode == 1) {
		Commands->Set_Health(obj,Commands->Get_Max_Health(obj));
		Commands->Set_Shield_Strength(obj,Commands->Get_Max_Shield_Strength(obj));
	}
}

/* ******************************************************************************************************** */

void M00_GrantPowerup_Created::Created(GameObject *obj) {
	if (SnipeMode == 1) {
		if (KilledWF == false) {
			Commands->Apply_Damage(Commands->Find_Object(WFID),99999,"Explosive",false);
		}
		if (KilledAir == false) {
			Commands->Apply_Damage(Commands->Find_Object(AirID),99999,"Explosive",false);
		}
		if (KilledBarr == false && KillSB == 1) {
			Commands->Apply_Damage(Commands->Find_Object(BarrID),99999,"Explosive",false);
		}
		if (KilledHON == false && KillSB == 1) {
			Commands->Apply_Damage(Commands->Find_Object(HONID),99999,"Explosive",false);
		}

		if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
			if (IgnoreBaseDefense == 1) Commands->Set_Is_Visible(obj,false);
			else if (IgnoreBaseDefense == 0) Commands->Set_Is_Visible(obj,true);

			if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);

			//Spawn Character
			if (strstr(Commands->Get_Preset_Name(obj),"GDI_MiniGunner_0")) {
				Commands->Clear_Weapons(obj);
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				Commands->Give_Powerup(obj,"POW_SniperRifle_Player",true);
				Commands->Select_Weapon(obj,"CnC_Weapon_SniperRifle_Player");
				Commands->Give_Powerup(obj,"CnC_POW_Ammo_ClipMax",true);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"Nod_Minigunner_0")) {
				Commands->Clear_Weapons(obj);
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				Commands->Give_Powerup(obj,"POW_SniperRifle_Player_Nod",true);
				Commands->Select_Weapon(obj,"CnC_Weapon_SniperRifle_Player_Nod");
				Commands->Give_Powerup(obj,"CnC_POW_Ammo_ClipMax",true);
			}
			//Deadeye and BH Sniper exceptions
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_2SF") && !strstr(Commands->Get_Preset_Name(obj),"Locke")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Minigunner_2SF")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
			}
			//Havoc and Sakura
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_3Boss")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillHS == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_3Boss_ALT2")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillHS == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_3Boss_ALT3")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillHS == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_GDI_MiniGunner_3Boss_ALT4")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillHS == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_Minigunner_3Boss")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillHS == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_MiniGunner_3Boss_ALT2")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillHS == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			//PIC Sydney and Raveshaw
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Sydney_PowerSuit")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillRB == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Sydney_PowerSuit_ALT2")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillRB == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_RocketSoldier_3Boss")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillRB == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			else if (strstr(Commands->Get_Preset_Name(obj),"CnC_Nod_RocketSoldier_3Boss_ALT2")) {
				if (AllowPistol == 1) Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
				if (KillRB == 1) Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
			//The other fargin bastages
			else {
				Commands->Apply_Damage(obj,99999,"Explosive",false);
			}
		}
	}
	else Commands->Give_Powerup(obj,Get_Parameter("WeaponDef"),true);
}

void M00_GrantPowerup_Created::Killed(GameObject *obj, GameObject *shooter) {
	if (SnipeMode == 1) {
		if (strstr(Get_Parameter("WeaponDef"),"POW_Pistol_Player")) {
			GameObject *BackpackObject;
			Commands->Give_Money(obj,(Commands->Get_Money(obj) * -1),false);
			Commands->Give_Money(obj,MoneytoGive,false);
			if (LogInfDeath == 1) {
				char Message[512];
				sprintf(Message,"INFDEATH %s %d %s %d",Commands->Get_Preset_Name(obj),Commands->Get_ID(obj),Commands->Get_Preset_Name(shooter),Commands->Get_ID(shooter));
				LogMessageInfDeath(Message);
			}
			if (DropWeapons == 1) {
				Vector3 DeathPlace = Commands->Get_Position(obj);
				BackpackObject = Commands->Create_Object("Invisible_Object",DeathPlace);
				Commands->Attach_Script(BackpackObject,"KAK_Backpack_Object",Commands->Get_Preset_Name(obj));
			}
		}
	}
}

/* ******************************************************************************************************** */

void KAK_Backpack_Object::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,5,1);
}

void KAK_Backpack_Object::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		GameObject *BackpackScript;
		Vector3 DeathPlace = Commands->Get_Position(obj);

		int RandomNum = Commands->Get_Random_Int(1,4);

		if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_0")) {
			BackpackScript = Commands->Create_Object("POW_SniperRifle_Player",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_0")) {
			BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Sydney_PowerSuit")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_PersonalIonCannon_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_RocketSoldier_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_Railgun_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}
		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_3Boss")) {
			if (RandomNum == 1) {
				BackpackScript = Commands->Create_Object("POW_RamjetRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_050",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_GDI_MiniGunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else if (strstr(Get_Parameter("CharacterType"),"CnC_Nod_Minigunner_2SF")) {
			if (RandomNum == 1 || RandomNum == 2) {
				BackpackScript = Commands->Create_Object("POW_SniperRifle_Player_Nod",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
			else {
				BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
				Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
				Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
			}
		}

		else {
			BackpackScript = Commands->Create_Object("POW_Armor_025",DeathPlace);
			Commands->Attach_Script(BackpackScript,"M00_Powerup_Destroy","");
			Commands->Attach_Script(BackpackScript,"KAK_Backpack","");
		}

		Commands->Send_Custom_Event(obj,BackpackScript,6000,Commands->Get_ID(obj),0);
	}
}

/* ******************************************************************************************************** */

void KAK_Backpack::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 6000) {
		SpawnedByID = param;
	}

	else if (message == 1000000025) {
		if (SpawnedByID != Commands->Get_ID(sender)) {
			Commands->Create_Object_At_Bone(obj,GunToGive,"muzzle");
			Commands->Destroy_Object(obj);
		}
	}

}

void KAK_Backpack::Register_Auto_Save_Variables() {
	Auto_Save_Variable(1,4,&SpawnedByID);	
}

/* ******************************************************************************************************** */

void KAK_Warp_On_Pickup::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == CUSTOM_EVENT_POWERUP) {
		Vector3 WarpPosition = Get_Vector3_Parameter("Position");
		Commands->Set_Position(sender,WarpPosition);
	}
}

/* ******************************************************************************************************** */

ScriptRegistrant<M00_BUILDING_EXPLODE_NO_DAMAGE_DAK> M00_BUILDING_EXPLODE_NO_DAMAGE_DAK_Registrant("M00_BUILDING_EXPLODE_NO_DAMAGE_DAK","");
ScriptRegistrant<M00_Disable_Transition> M00_Disable_Transition_Registrant("M00_Disable_Transition","");
ScriptRegistrant<M00_GrantPowerup_Created> M00_GrantPowerup_Created_Registrant("M00_GrantPowerup_Created","WeaponDef:string");
ScriptRegistrant<KAK_Backpack> KAK_Backpack_Registrant("KAK_Backpack","");
ScriptRegistrant<KAK_Backpack_Object> KAK_Backpack_Object_Registrant("KAK_Backpack_Object","CharacterType:string");
ScriptRegistrant<KAK_Warp_On_Pickup> KAK_Warp_On_Pickup_Registrant("KAK_Warp_On_Pickup","Position:Vector3");
