class M00_BUILDING_EXPLODE_NO_DAMAGE_DAK : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed(GameObject * obj,GameObject * shooter);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Destroyed(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	int totalbuildings;
	char buildingID[100];
	char buildingPosX[50];
	char buildingPosY[50];
	char buildingPosZ[50];
	char totalbuildings_string[100];
	char newtotalbuildings_string[100];
	FILE *f;
	float TotalHealth;
	int IntHealth;
};

class M00_Disable_Transition : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed(GameObject * obj,GameObject * shooter);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Timer_Expired(GameObject *obj,int number);
	int totalbuildings;
	char buildingID[100];
	char buildingPosX[50];
	char buildingPosY[50];
	char buildingPosZ[50];
	char totalbuildings_string[100];
	char newtotalbuildings_string[100];
	FILE *f;
	float TotalHealth;
	int IntHealth;
	Vector3 HarvyPos;
};

class M00_GrantPowerup_Created : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	void Timer_Expired(GameObject *obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Destroyed(GameObject *obj);
	GameObject *BackpackObject;
	GameObject *BackpackScript;
	Vector3 DeathPlace;
	bool IsKamiKaze;
	bool IsSecondWind;
	bool IsTibSuit;
};

class KAK_Backpack : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	char GunToGive[512];
	int SpawnedByID;
};

class KAK_Backpack_Object : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	GameObject *BackpackScript;
	Vector3 DeathPlace;
};

class M00_CNC_Crate : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
	int RandomIntCrate;
	char CrateMessage[512];
	char Message2Send[512];
	GameObject *vehBlocker;
};

class KAK_Temp_Crate : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};

class KAK_Rebuy_BD : public ScriptImpClass {
	void Killed(GameObject *obj, GameObject *shooter);
};
class KAK_Rebuy_Box : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
};


/*class KAK_Building_Repurchase_Crate : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};*/

class KAK_Beacon_Log : public ScriptImpClass {
	void Created(GameObject *obj);
	void Destroyed(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
	bool IsDisarmed;
	GameObject *InvisObjCont;
};

class KAK_Beacon_Animation_Log : public ScriptImpClass {
	void Created(GameObject *obj);
};

class KAK_Beacon_Log_CreateControl : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Vehicle_Log : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed(GameObject *obj, GameObject *shooter);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);

	int TotalSeats, SeatsTaken, Seat1, Seat2, Seat3, Seat4, Seat5;
	GameObject *DestroyedTank;
	Vector3 DeadPlace;
	float Facing;
};

class KAK_Vehicle_Death : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Timer_Expired(GameObject *obj, int number);
	int MaxHealth, CurrHealth;
	GameObject *DestroyedTank;
	Vector3 DeadPlace;
	float Facing;
};

class KAK_Ped_Beacon_Controller : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Entered(GameObject *obj, GameObject *enter);
};

class KAK_Random_Weather : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	int LastWeather;
};

class KAK_Create_Beacon_Death : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Tiberium_Zone : public ScriptImpClass {
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Entered(GameObject *obj, GameObject *enter);
};