#define REQ_SPAWN 23515

class KAK_Weapon_Spawner : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *Obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	int LastDrawnGun;
	GameObject *Gun, *Starter;
	bool DrawGun, DestroyStart;
	bool AllowKill;
};

class KAK_Weapon_Spawner_Restart : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *Obj, int number);
};

class M00_GrantPowerup_Created : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	void Timer_Expired(GameObject *obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Destroyed(GameObject *obj);
	GameObject *BackpackObject;
	GameObject *BackpackScript;
	Vector3 DeathPlace;
	bool IsKamiKaze;
	bool IsSecondWind;
	bool IsTibSuit;
	bool FullKill;
	Vector3 SpawnPos;
	int AfkDetect;
	bool DidEvent;
	bool SpawnProtect;
	GameObject *SpawnObj;
	int KillCount, TotalKills, GunNumber;
};	

class KAK_Ammo_Spawner : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *Obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	int LastDrawnGun;
	GameObject *Temp, *Starter;
	bool DrawGun, DestroyStarter;
	bool AllowKill;
};

class KAK_Ammo_Spawner_Pickup : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *Obj, int number);
};

class KAK_Melee_Spawner : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *Obj, int number);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	int LastDrawnGun;
	GameObject *Temp, *Starter;
	bool DrawGun, DestroyStarter;
	bool AllowKill;
};

class KAK_Melee_Spawner_Pickup : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *Obj, int number);
};

class KAK_Prevent_Kill : public ScriptImpClass {
	void Damaged(GameObject *obj, GameObject *damager, float damage);
};

class KAK_Set_Pedestal_Type : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	GameObject *POW;
};

class M00_PCT_Pokable_DAK : public ScriptImpClass {
	void Created(GameObject *obj);
};

class M00_Disable_Transition : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class KAK_Disable_Transition : public ScriptImpClass {
	void Created(GameObject *obj);
};

class KAK_Random_Weather : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	float Range, CurrentClouds, CurrentRain, CurrentLightning, CurrentSnow, CurrentAsh, CurrentWind;
	char MapName[256], IDNum[10];
};

class KAK_ConsoleCommand : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class M00_BUILDING_EXPLODE_NO_DAMAGE_DAK : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Destroyed(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Killed(GameObject *obj, GameObject *shooter);
	bool IsDead;
};

class KAK_DM_Refresh_Spawn : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
};

class M08_Helipad : public ScriptImpClass {
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Destroyed(GameObject *obj);
	void Timer_Expired(GameObject *obj, int number);
	void Killed(GameObject *obj, GameObject *shooter);
	bool IsDead;
};