extern int Exe;
void InitEngine();
GameObject *Get_GameObj(int ID);
GameObject *Find_Player_GameObj(const char *Name);
int Get_Player_ID(GameObject *obj);
const char *Get_Model(GameObject *obj);
int Get_Object_Type(GameObject *obj);
bool Change_Character(GameObject *obj,const char *Preset_Name);
const char *WideCharToChar(const wchar_t* ptr);
const char *Get_Player_Name(GameObject *obj);
GameObject *Find_Building_By_Team(int Team);
GameObject *Find_Building_By_Name(int Team, const char *Preset_Name);
void Kill_All_Buildings_By_Team(int Team);
void Damage_All_Buildings_By_Team(int Team,float Damage,const char *Warhead);
void Damage_All_Buildings_By_Team_Nearest(int Team,float Damage,const char *Warhead,const Vector3 &Position,float Distance);
void Damage_All_Buildings_By_Team_Nearest_Scale(int Team,float Damage,const char *Warhead,const Vector3 &Position,float Distance);
void Repair_All_Buildings_By_Team(int Team,int ConstructionYardID,float Health);
void Damage_All_Objects_Area(float Damage,const char *Warhead,const Vector3 &Position,float Distance,GameObject *Host,GameObject *Damager);
void Damage_All_Vehicles_Area(float Damage,const char *Warhead,const Vector3 &Position,float Distance,GameObject *Host,GameObject *Damager);
GameObject *Find_Smart_Object_By_Team(int Team);
GameObject *Find_Object_By_Team(int Team);
GameObject *Find_Non_Player_Object_By_Team(int Team);
GameObject *Find_Object_By_Preset(int Team,const char *Preset_Name);
GameObject *Find_Base_Defense(int Team);
GameObject *Find_Power_Plant(int Team);
GameObject *Find_Refinery(int Team);
GameObject *Find_Repair_Bay(int Team);
GameObject *Find_Soldier_Factory(int Team);
GameObject *Find_Airstrip(int Team);
GameObject *Find_War_Factory(int Team);
GameObject *Find_Vehicle_Factory(int Team);
GameObject *Find_Com_Center(int Team);
bool Is_Building(GameObject *obj);
bool Is_Soldier(GameObject *obj);
bool Is_Vehicle(GameObject *obj);
bool Is_Cinematic(GameObject *obj);
bool Is_ScriptZone(GameObject *obj);
bool Is_TrackedVehicle(GameObject *obj);
bool Is_VTOLVehicle(GameObject *obj);
bool Is_WheeledVehicle(GameObject *obj);
bool Is_Motorcycle(GameObject *obj);
void Set_Max_Health(GameObject *obj,float health);
void Set_Max_Shield_Strength(GameObject *obj,float shieldstrength);
GameObject *Find_First_Player(int Team);
float Get_Animation_Frame(GameObject *obj);
void Grant_Refill(GameObject *obj);
void Grant_Powerup(GameObject *obj,const char *Preset_Name);
GameObject *Get_Vehicle(GameObject *obj);
const char *Get_Shield_Type(GameObject *obj);
const char *Get_Skin(GameObject *obj);
void Set_Skin(GameObject *obj,const char *Skintype);
void Create_Vehicle(const char *Preset_Name, float Delay, GameObject *Owner, int Team);
void Toggle_Fly_Mode(GameObject *obj);
