class RA_Thief_Script: public ScriptImpClass {
	bool enabled;
	void Timer_Expired(GameObject * obj,int number);
	void Entered(GameObject * obj,GameObject * enter);
	void Created(GameObject * obj);
	void Register_Auto_Save_Variables();
};

class RA_Soviet_Defence : public ScriptImpClass {
	unsigned int id1;
	unsigned int id2;
	unsigned int id3;
	unsigned int objtype;
	void Created(GameObject * obj);
	void Enemy_Seen(GameObject * obj,GameObject * seen);
	void Action_Complete(GameObject * obj,int action,ActionCompleteReason reason);
	void Timer_Expired(GameObject * obj,int number);
	void Register_Auto_Save_Variables();
};
class RA_Repair_Controller : public ScriptImpClass {
	void Killed(GameObject * obj,GameObject * shooter);
};
class RA_Repair_Script : public ScriptImpClass {
	void Entered(GameObject * obj,GameObject * enter);
	void Timer_Expired(GameObject * obj,int number);
};

class RA_Soviet_Refinery_Controller : public ScriptImpClass {
	void Killed(GameObject * obj,GameObject * shooter);
};

class RA_Soviet_Refinery_Theft_Zone : public ScriptImpClass {
	bool refinery;
//	int sovietID; //stores the ID of the soviet refinery
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Entered(GameObject *obj, GameObject *enter);
	void Exited(GameObject *obj, GameObject *exit);
	void Register_Auto_Save_Variables();
};

class RA_Allied_Thief : public ScriptImpClass {
	bool stealing;
	bool ready; // controls timer lockout of zone entry money award
//	int sovietID; //stores an ID of a soviet object to steal from
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
	void Register_Auto_Save_Variables();
};

class RA_Infantry_Spy : public ScriptImpClass {
	void Created(GameObject *obj);
};

class RA_Infantry_NotSpy : public ScriptImpClass {
	void Created(GameObject *obj);
};

class RA_Helipad_Zone : public ScriptImpClass {
	void Entered(GameObject * obj,GameObject * enter);
	void Timer_Expired(GameObject * obj,int number);
};

class RA_MineLayer : public ScriptImpClass {
	int driverID;
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int mesage, int param, GameObject *sender);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Register_Auto_Save_Variables();
};

class RA_Mine : public ScriptImpClass {
	bool AP_mine;
	bool AT_mine;
	void Created(GameObject *obj);
	void Enemy_Seen(GameObject *obj, GameObject *seen);
	void Destroyed(GameObject *obj); //Replaced Killed
	void Register_Auto_Save_Variables();
};

class RA_Mine_Manager : public ScriptImpClass {
	int all_mines;
	int sov_mines;
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Register_Auto_Save_Variables();
};

class RA_ObjectDeath_OnCreate : public ScriptImpClass {
	void Created(GameObject *obj);
};

class RA_Naval_Yard : public ScriptImpClass {
	int team_count;
	bool active;
	bool ready;
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Killed(GameObject *obj, GameObject *shooter);
	void Timer_Expired(GameObject *obj, int number);
	void Register_Auto_Save_Variables();
};

class RA_Naval_PT : public ScriptImpClass {
	int storedID;
	void Created(GameObject *obj);
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
	void Timer_Expired(GameObject *obj, int number);
	void Register_Auto_Save_Variables();
};

class RA_Naval_Unit : public ScriptImpClass {
	void Destroyed(GameObject *obj);
};

class RA_Naval_Zone : public ScriptImpClass {
	void Custom(GameObject *obj, int message, int param, GameObject *sender);
};

